unit mbs_cnt;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfCnt =
	class(TForm)
		par: TGroupBox;
    	pin: Tmbs_led;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure RecMess(fld: tmbs_fld; mess: boolean);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(fld: tmbs_fld);
	end;

var
	fCnt: 		TfCnt;

implementation

uses mbs_bea_u;

{$R *.DFM}

procedure TfCnt.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfCnt.GetPar;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		mw.w.Stan := 2;
		st0.Visible := false;
		st1.Visible := false;
		st2.Visible := false;
		st3.Visible := false;
		pin.adr := mw.w.ad[0];
		par.Caption := sftab[integer(mw.w.ftyp)];
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfCnt.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[0] := pin.Adr;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);
		st0.Visible := false;
		st1.Visible := false;
		st2.Visible := false;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfCnt.draw(fld: tmbs_fld);
const
	d = gr div 3 - 1;
	r: TRect = (left: d + 1;		Top: d + 1;
					Right: gr - d; 	bottom: gr - d);
begin
	with mw.bm.Canvas
	do begin
		pen.Width := 2;
		if fld.FTyp = ftSkt
		then pen.Color := clgray;
		if fld.FTyp = ftGkt
		then pen.Color := clblack;
		if fld.stat = sta1
		then brush.Color := cllime
		else brush.Color := pen.color;
		ellipse(r);
	end;
end;

// empangene meldungen
procedure TfCnt.RecMess(fld: tmbs_fld; mess: boolean);
var
	v:				Tmbs_vrb;
	nf:			Tmbs_fld;
begin
	if not mess
	and (fld.Stat = sta1)	// Zug verlsst den Kontakt
	then begin					// Verbundene Signale auf rot stellen
		fld.FstVerb;         // und zurck freigeben
		while fld.GetVerb(v)
		do begin
			if v.wst = sta0	// Verb mit fallender Flanke
									// block freigeben
									// verbindung entfernen
			then begin
				nf := mw.ftab[v.x, v.y];
				if fld.FTyp = ftHsi
				then begin
					if v.sst = sst0
					then begin
						nf.Stat := tsta(v.sst);
						nf.Zugw := 0;
						nf.freig(fld.Conn, fld.Zugn, true);
					end;
					fld.DelVerb(v);
					nf.Paint(0);
					break;
				end;
			end;
		end;
	end;
	if mess
	and (fld.Stat = sta0)	// Zug betritt den Kontakt
	then begin					// Verbundene Signale auf rot stellen
		fld.FstVerb;
		while fld.GetVerb(v)
		do begin
			if v.wst = sta0	// Verb mit fallender Flanke Flanke
			then begin
				nf := mw.ftab[v.x, v.y];
				if fld.FTyp = ftHsi
				then begin
					if v.sst = sst0
					then begin
						nf.freig(fld.Conn, fld.Zugw, false);
					end;
					break;
				end;
			end;
		end;
	end;
	fld.setstatcom(fld.stat);
end;

// statusnderung
procedure TfCnt.SetStat(fld: tmbs_fld; stat: tsta);
begin
	fld.setstatcom(stat);
end;

// statusnderung durch Click
procedure TfCnt.ChngStat;
begin
	mw.w.NextStat;			// umschalten
end;

// statustabelle versorgen
procedure TfCnt.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptinp;
	fld.stan := 2;
end;

end.
