unit mbs_cvb_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls;

{$i hersteller.inc}

type
	twrtchg = (wcbit, wcdec, wchex, wcchr);

	Tmbs_cvb_f =
	class(TForm)
		lbwrt: TLabel;
		lbber: TLabel;
		ewrt: TEdit;
		Button1: TButton;
		Button2: TButton;
		hwrt: TEdit;
		b7: TCheckBox;
		b6: TCheckBox;
		b5: TCheckBox;
		b4: TCheckBox;
		b3: TCheckBox;
		b2: TCheckBox;
		b1: TCheckBox;
		b0: TCheckBox;
		defwrt: TButton;
		Label1: TLabel;
		ebez: TLabel;
		ebem: TLabel;
		cwrt: TEdit;
		Button3: TButton;
		Label2: TLabel;
	 	Label3: TLabel;
		procedure FormActivate(Sender: TObject);
		procedure wrtClick(Sender: TObject);
		procedure bitenter(Sender: TObject);
		procedure ewrtEnter(Sender: TObject);
		procedure hwrtEnter(Sender: TObject);
		procedure ewrtChange(Sender: TObject);
		procedure hwrtChange(Sender: TObject);
		procedure cwrtChange(Sender: TObject);
		procedure cwrtEnter(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure bitClick(Sender: TObject);
	private		{ Private-Deklarationen }
		wrtchg: twrtchg;
		cbtab: array [0..7] of tcheckbox;
	public		{ Public-Deklarationen }
		cvnum: word;
		cvwrt: word;
		def,
		ber,
		bez,
		bem: string;
		rdo: boolean;
		bit: array [0..7] of string;
		spt: byte;
	end;

var
	mbs_cvb_f: Tmbs_cvb_f;

implementation

{$R *.DFM}

uses mbs_spt_u;

procedure setcap(cb: tcheckbox; bez: string);
var
	m,
	n:			integer;
	s1,
	s2:			string;
begin
	m := pos(',', bez);
	n := pos(',', copy(bez, m + 1, 255));
	if n = 0
	then begin
		cb.Caption := bez;
		if bez <= ' '
		then cb.hint := ''
		else cb.Hint := '1 = ' + bez;
	end
	else begin
		s1 := copy(bez, m + 1, n - 1);
		s2 := copy(bez, m + n + 1, 255);
		if not cb.Checked
		then cb.Caption := copy(bez, 1, m - 1) + ': '
						+ s1
		else cb.Caption := copy(bez, 1, m - 1) + ': '
						+ s2;
		cb.Hint := '0 = ' + s1 + #13 + #10
					+ '1 = ' + s2;
	end;
end;

procedure Tmbs_cvb_f.FormActivate(Sender: TObject);
var
	z:			integer;
begin
	Caption := 'CV ' + inttostr(cvnum);
	wrtchg := wcdec;
	ewrt.Text := inttostr(cvwrt);
	ewrt.Tag := cvwrt;
	hwrt.Text := format('%2.2x', [cvwrt]);
	cwrt.Text := char(cvwrt);
	if rdo
	then begin
		ewrt.Enabled := false;
		hwrt.Enabled := false;
		cwrt.Enabled := false;
		b0.Enabled := false;
		b1.Enabled := false;
		b2.Enabled := false;
		b3.Enabled := false;
		b4.Enabled := false;
		b5.Enabled := false;
		b6.Enabled := false;
		b7.Enabled := false;
		defwrt.Visible := false;
		lbber.Visible := false;
		button1.Visible := false;
		button3.Caption := 'beschreibbar';
	end
	else begin
		ewrt.Enabled := true;
		hwrt.Enabled := true;
		cwrt.Enabled := true;
		b0.Enabled := true;
		b1.Enabled := true;
		b2.Enabled := true;
		b3.Enabled := true;
		b4.Enabled := true;
		b5.Enabled := true;
		b6.Enabled := true;
		b7.Enabled := true;
		defwrt.Visible := true;
		lbber.Visible := true;
		button1.Visible := true;
		button3.Caption := 'nur lesen';
		ewrt.SetFocus;
		ewrt.SelectAll;
	end;
	defwrt.caption := def;
	defwrt.Tag := strtoint(def);
	ebez.Caption := bez;
	if cvnum = 8
	then ebem.Caption := htab[cvwrt]
	else ebem.Caption := bem;
	for z := 0 to 7
	do begin
		setcap(cbtab[z], bit[z]);
	end;
	lbber.Caption := ber;
end;

procedure Tmbs_cvb_f.bitClick(Sender: TObject);
var
	e:			byte;
begin
	if wrtchg <> wcbit
	then exit;
	setcap(tcheckbox(sender),
				bit[tcheckbox(sender).tag]);
	e := byte(b7.Checked) * 128
		+ byte(b6.Checked) * 64
		+ byte(b5.Checked) * 32
		+ byte(b4.Checked) * 16
		+ byte(b3.Checked) * 8
		+ byte(b2.Checked) * 4
		+ byte(b1.Checked) * 2
		+ byte(b0.Checked);
	hwrt.Text := format('%2.2x', [e]);
	cwrt.Text := char(e);
	ewrt.Text := inttostr(e);
	cvwrt := e;
end;

procedure Tmbs_cvb_f.wrtClick(Sender: TObject);
begin
	with sender as tbutton
	do begin
		wrtchg := wcdec;
		ewrt.Text := Caption;
	end;
end;

procedure Tmbs_cvb_f.bitenter(Sender: TObject);
begin
	wrtchg := wcbit;
end;

procedure Tmbs_cvb_f.ewrtEnter(Sender: TObject);
begin
	wrtchg := wcdec;
end;

procedure Tmbs_cvb_f.hwrtEnter(Sender: TObject);
begin
	wrtchg := wchex;
end;

procedure Tmbs_cvb_f.ewrtChange(Sender: TObject);
begin
	if wrtchg <> wcdec
	then exit;
	ewrt.Tag := 0;
	if ewrt.Text > ''
	then begin
		try
			ewrt.Tag := strtoint(ewrt.text);
		except
		end;
	end;
	cvwrt := ewrt.tag;
	hwrt.Text := format('%2.2x', [ewrt.tag]);
	cwrt.Text := char(ewrt.Tag);
	ewrt.Text := inttostr(ewrt.Tag);
	b7.checked := ((ewrt.tag and 128) > 0);
	b6.checked := ((ewrt.tag and 64) > 0);
	b5.checked := ((ewrt.tag and 32) > 0);
	b4.checked := ((ewrt.tag and 16) > 0);
	b3.checked := ((ewrt.tag and 8) > 0);
	b2.checked := ((ewrt.tag and 4) > 0);
	b1.checked := ((ewrt.tag and 2) > 0);
	b0.checked := ((ewrt.tag and 1) > 0);
end;

procedure Tmbs_cvb_f.hwrtChange(Sender: TObject);
begin
	if wrtchg <> wchex
	then exit;
	hwrt.Tag := 0;
	if hwrt.Text > ''
	then begin
		if length(hwrt.Text) > 2
		then hwrt.text := copy(hwrt.text, 2, 2);
		try
			hwrt.Tag := strtoint('$' + hwrt.Text);
		except
		end;
	end;
	cvwrt := hwrt.tag;
	hwrt.Text := format('%2.2x', [hwrt.tag]);
	hwrt.sellength := 0;
	hwrt.selstart := 2;
	cwrt.Text := char(hwrt.tag);
	ewrt.Text := inttostr(hwrt.Tag);
	b7.checked := ((hwrt.tag and 128) > 0);
	b6.checked := ((hwrt.tag and 64) > 0);
	b5.checked := ((hwrt.tag and 32) > 0);
	b4.checked := ((hwrt.tag and 16) > 0);
	b3.checked := ((hwrt.tag and 8) > 0);
	b2.checked := ((hwrt.tag and 4) > 0);
	b1.checked := ((hwrt.tag and 2) > 0);
	b0.checked := ((hwrt.tag and 1) > 0);
end;

procedure Tmbs_cvb_f.cwrtChange(Sender: TObject);
begin
	if wrtchg <> wcchr
	then exit;
	cwrt.Tag := 0;
	if cwrt.Text > ''
	then begin
		try
			cwrt.Tag := ord(cwrt.text[1]);
		except
		end;
	end;
	cvwrt := cwrt.tag;
	hwrt.Text := format('%2.2x', [cwrt.tag]);
	cwrt.Text := char(cwrt.tag);
	ewrt.Text := inttostr(cwrt.Tag);
	b7.checked := ((cwrt.tag and 128) > 0);
	b6.checked := ((cwrt.tag and 64) > 0);
	b5.checked := ((cwrt.tag and 32) > 0);
	b4.checked := ((cwrt.tag and 16) > 0);
	b3.checked := ((cwrt.tag and 8) > 0);
	b2.checked := ((cwrt.tag and 4) > 0);
	b1.checked := ((cwrt.tag and 2) > 0);
	b0.checked := ((cwrt.tag and 1) > 0);
end;

procedure Tmbs_cvb_f.cwrtEnter(Sender: TObject);
begin
	wrtchg := wcchr;
end;

procedure Tmbs_cvb_f.FormCreate(Sender: TObject);
begin
	cbtab[0] := b0;
	cbtab[1] := b1;
	cbtab[2] := b2;
	cbtab[3] := b3;
	cbtab[4] := b4;
	cbtab[5] := b5;
	cbtab[6] := b6;
	cbtab[7] := b7;
end;

end.
