unit mbs_fld;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, StdCtrls, ExtCtrls, ComCtrls, Dialogs,
	inifiles, registry, menus;

const
	vf = 'V%2.2d:%3d bei:%d->%3d:%-3d';
	ve = 'V%2.2d:%3d bei:%d->...... ';
	safld = $8000;
	satim = $2000;
	saart = $F000;
	dtabm = 127;
	ttabm = 63;
	ktabm = 31;
	staon = $8080;
	staof = $8000;
	fmir = 4;
	fmis = 4;
	fmi2 = 3;


	gr = 16;
	gr2 = gr div 2;
	re: Trect = (left: 0; top: 0; right: gr + 1; bottom: gr + 1);
	con = 1;
	cono = 2;
	coo = 4;
	coso = 8;
	cos = 16;
	cosw = 32;
	cow = 64;
	conw = 128;

	ein = $10;
	aus = $00;

	vst: array [0..7] of byte = ($0c, $1c, $18, $1a, 0, 0, 0, 0) ;
	hst: array [0..3] of byte = ($10, $08, $0c, $04);
	sig4 = 1;
	sig6 = 2;
	sigr = 3;
	fvlstm = 31;
	ttgr = 10;
	sftab: array [0..22] of string =
		('none',
		'Ausgang',
		'Gleis',
		'Weiche', '3W-Weiche', 'EK-Weiche', 'DK-Weiche',
		'H-Signal', 'V-Signal',
		'G-Kontakt',
		'Schranke',
		'Fahrstrasse',
		'Drehscheibe',
		'Brcke',    { TODO :  mit isolationen darstellen}
		'Gls.Ende',
		'',
		'Strasse',
		'Abzweigung',
		'Haltestelle',
		'S-Kontakt',
		'Ampel',
		'Str.Ende',
		'');

	sptab: array [0..6] of string =
		('none'
		,'Ampel'
		,'hSignal'
		,'Servo'
		,'Ausgang'
		,'Kontakt'
		,'vSignal'
		);

type
	TTtyp = (ttnone, ttstart, tttag, ttabend, ttnacht);
	TTsta = (tsleer, tsbeg, tsbon, tson, tsrdy);

	tpar = (par0, par1, par2, par3);
	tsta = (sta0, sta1, sta2, sta3, sta4, sta5, sta6, sta7,
				belp, belm);
	tsst = (sst0, sst1, sst2, sst3, sst4, sst5, sst6, sst7,
				sblp, sblm);

const
	leer = ($80);
	parl = tpar($80);
	stal = tsta($80);
	sstl = tsst($80);

type
	TSend = 	procedure(prt: byte; dat: string) of object;
	TFTyp = (ftNon,
				ftAus,
				ftGls,
				ftTrn, ft3wg, ftEkw, ftDkw,
				ftHsi, ftVsi,
				ftGkt,
				ftLck,
				ftFst,
				ftDrs,
				ftBrk,
				ftEnd,
				ftx1,
				ftStr,
				ftAbz,
				ftStp,
				ftSkt,
				ftAmp,
				ftSte,
				fty1,
				ftype);

	TPTyp = (ptnon,
				ptamp,
				pthsi,
				ptsrv,
				ptout,
				ptinp,
				ptvsi);

	Tmbs_vrb =
	record
		wst:	tsta;    // bei Wechsel zu Status
		x,					// pos x
		y,				   // Pos y
		rpz,           // richtung pinnummer zeit
		fix,				// fixe verbindung
		zug:	byte;		// zugnummer
		sst:	tsst; 	// setze Status
		dyn:	boolean; // wenn true, nach verarbeitung lschen
//		par:	longint; // einstellparameter
	end;

	pTVrb = ^Tmbs_vrb;
	TaVrb = array [0..31] of Tmbs_vrb;
	Tabyte3 = array [par0..par3] of byte;
	Tabyte7 = array [sta0..sta7] of byte;

	THead =
	record
		leng:		word;
		Posx,
		Posy:		byte;   			// position
	end;

	Tmbs_adr =
	record
//**		po:		byte;			// port
		xx:		byte;
		dv:		byte;			// device
		dc:		word;			// decoder
		ms:		Tabyte7;		// messages
	end;

const
//**	adr_leer: tmbs_adr = (po: 0; dv: 0; dc: 0;
//**			ms: (leer, leer, leer, leer, leer, leer, leer, leer));
	adr_leer: tmbs_adr = (xx: 0; dv: 0; dc: 0;
			ms: (leer, leer, leer, leer, leer, leer, leer, leer));

type
	TFeld =
	record
		FTyp:	TFTyp;			// Feldtyp
		PTyp:	TPTyp;	      // Pintyp
		Posx,
		Posy,         			// position
		Conn,						// Verbindungen zu nachbarn
		Isol: byte;				// isoliert
		Stat,			         // Status
		VSta: tsta;          // Status bearbeiten
		Stan,                // # Stati
		Farb,				      // Zeichenbereich (timage)
		Zugn,						// belegt von Zug / farbe
		Zugw,						// Zug wartet
		Wurz,			       	// Wurzel bei Weiche
		Blgt:	byte;				// belegt von lok/wagen
		Vlst:	TaVrb;			// verbundene Felder
		Stab:	tabyte7;       // info pro Status 0-7
		Parm:	tabyte3;			// interne parameter;
		Adrt: array [0..3] of tmbs_adr;
	end;

	pTFeld = ^TFeld;

	Tmbs_fld =
	class(TComponent)
	private		{ Private-Deklarationen }
		F:				TFeld;
		FVind:		byte;				// current verbindung
//		FSend:		tSend;
		FMess:		boolean;
		FDoVerb:		boolean;
		procedure	kreuz(var b: TBitmap; c: TColor);
	protected	{ Protected-Deklarationen }
		procedure setstr;
		procedure DoVerb(stat: tsta);
		procedure SetFTyp(Value: TFTyp);
		procedure SetStab;
		procedure SetZugn(Value: byte);
		procedure SetZugw(Value: byte);
		procedure SetConn(Value: byte);
		procedure SetIsol(Value: byte);
		procedure SetStat(Value: tsta);
		procedure SetBlgt(Value: byte);
		procedure RecMess(Value: boolean);
		function	GetStat(): tsta;
		procedure SetPos(Value:	tpoint);
		function	GetPos(): tpoint;
		procedure SetAd(Index: byte; Value: tmbs_adr);
		function GetAd(Index: byte): tmbs_adr;
		procedure HSiChange(p: tpoint);
		procedure HSiSetState(f: Tmbs_fld; Value: tsta);
		function	GetZ: ptfeld;
	public		{ Public-Deklarationen }
		constructor Createxy(AOwner: TComponent;
							x, y: byte);
							overload;
		procedure setstatcom(value: tsta);
		procedure putcom;
		procedure putpar;
		procedure puttst(
							dev: byte;
							par: tpar;
							sta: tsta);
		procedure Mouseup();
		procedure Mousedown(i: timage;
							b: tmousebutton);
		function	bwdir(rpz:	byte): byte;
		function	fwdir(rpz:	byte): byte;
		procedure DrawConn(f, pw1, pw2: byte);
		procedure Paint(Mode: byte);
		procedure Copy(vf: Tmbs_fld);
		procedure NextStat;
		function	GetWurz: byte;
		function	GetStab: byte;
		function	Next(rpz: byte): byte;
		function	Next2(rpz: byte): byte;
		function Bel_Pos(var verb: Tmbs_vrb; start: boolean): boolean;
		function Nxt_Pos(var rpz: byte): Tmbs_fld;

		procedure AddVerb(v: Tmbs_vrb);					overload;
		procedure AddVerb(f: Tmbs_fld; sst: tsst);		overload;
		procedure DelVerb(fix: boolean);					overload;
		procedure DelVerb(v: Tmbs_vrb);					overload;
		procedure DelVerb(f: Tmbs_fld; sst: tsst);		overload;
		procedure CngVerb(ber: trect; difx, dify: byte);overload;
		procedure CngVerb(p1, p2: tpoint);					overload;
		procedure FstVerb;
		function	GetVerb(var v: Tmbs_vrb): boolean;	overload;
		function GetVerb(var v: Tmbs_vrb;
								ind: byte): boolean;				overload;
		function GetVerbStr(var vrb: Tmbs_vrb;
								var str: string;
								var ind: byte): boolean;		overload;
		function	FndVerb(v: Tmbs_vrb): boolean;
		procedure ShwVerb(lb: TListBox);					overload;
		procedure ShwVerb(lb: TListBox; sta: tsta);   overload;

		function	beleg(rpz, zug: byte; cont, vsig: Tmbs_fld): boolean;
		procedure freig(rpz, zug: byte; cont: boolean);
		procedure SetMess(ind: byte; sta: tsta; m: byte);
																		overload;
		procedure SetMess(ind: byte; m: array of byte);
																		overload;
//		procedure SetDPar(ind: byte; par: tpar; val: byte);
//		function GetDPar(ind: byte; par: tpar): byte;
		function GetIpar(par: tpar): byte;
		procedure SetIPar(par: tpar; val: byte);
		procedure SaveFeld(var fi: file);
		procedure LoadFeld(var fi: file; lng: integer);
		procedure Anzeige(lb: tlistbox; num: byte);
		procedure AnzVerb(lb: tlistbox; d: byte; v: Tmbs_vrb);
		property	FTyp:			TFTyp				read	F.FTyp
														write	SetFTyp;
		property	PTyp:			TPTyp				read	F.PTyp
														write	F.PTyp;
		property	X:				byte				read	F.Posx;
		property	Y:				byte				read	F.Posy;
		property	Pos:			tpoint			read	GetPos
														write SetPos;
		property	Ad[i: byte]:
									tmbs_adr			read	GetAd
														write	SetAd;
		property	Zugn:			byte				read	F.Zugn
														write	F.Zugn;
		property	Zugw:			byte				read	F.Zugw
														write	F.Zugw;
		property	Conn:			byte				read	F.Conn
														write	SetConn;
		property	Isol:			byte				read	F.Isol
														write	SetIsol;
		property	Stat:			tsta				read	GetStat
														write	SetStat;
		property	VSta:			tsta				read	F.VSta;
		property	Stan:			byte				read	F.Stan
														write F.Stan;
		property	Wurz:			byte				read	F.Wurz;
		property	Farb:			byte				read	F.Farb
														write	F.Farb;
		property	Blgt:			byte				read	F.Blgt;
		property	Mess:			boolean			read	FMess
														write RecMess;
		property	Tag;
//		property	Send:			tsend				read	FSend
//														write FSend;
		property	Stab:			byte				read	GetStab;
//														write SetStab;
		property	RcvM:			boolean			write RecMess;
		property   Z:				ptfeld			read	GetZ;
	published   { Published-Deklarationen }
	end;

	Tmbs_Tim =
	record
		t:		ttsta;
		c,            			// laufende zeit
		a:		integer;			// wie oft noch
		f:		tmbs_fld;
		z:		tttyp;
		b,							// zeit bis on
		o,							// zeit on
		r,							// reload bis on
		w:		smallint;		// wie oft
		s:		boolean;			// status erhhen
		l:		boolean;			// wenn fertig lschen
	end;
	ptmbstim = ^tmbs_tim;

	Tmbs_kTi =
	record
		c:		smallint;		// laufende zeit
		n:		boolean;
		s:		tsta;
		f: 	tmbs_fld;
	end;
	ptmbskti = ^tmbs_kti;

	Tmbs_dec =
	record
		a:		boolean; 							// ist da
		c:		byte;									// mbs_mon_f port 1..4
		t:		array [1..13] of tptyp;			// pin type
		f:		array [1..13] of tmbs_fld;		// zugeordnetes feld
		n:		array [1..13] of string;  		// dev namen
		s:		string;								// decoder name
		px:		array [1..13, 0..3] of byte;  // deviceparameter;
	end;

	Tftab = array [1..127, 0..127] of Tmbs_fld;
	pTftab = ^Tftab;
	Tdtab = array [1..dtabm] of Tmbs_dec;
	pTdtab = ^Tdtab;
	Tttab = array [1..ttabm] of Tmbs_tim;
	pTttab = ^Tttab;
	Tktab = array [1..ktabm] of Tmbs_kti;
	pTktab = ^Tktab;

	tmbswork =
	record
		typlst:		tstringlist;
		run:			boolean;
		pri:			smallint;	// printerindex
		mode:       shortint;
		test:			boolean;
		kmin:			word;			// msek / takt
		min,							// sek / minute
		ftabx,
		ftaby,
		trenn:		byte;			// trennung i1 i2
		i1,
		i2:			TImage;
		mext,
		muhr,
		mmon,
		mo1,
		mo2:			Tmenuitem;
		tim:			tttyp;		// wert fr timer
		zmor,
		ztag,
		zabe,
		znch:			integer;
		w,
		v:          Tmbs_fld;
		ftab:			Tftab;
		dtab:			Tdtab;
		sdec,
		sdev,
		styp:	string;
//		ztab:			Tztab;
		ttab:			Tttab;		// langzeittimer
		ktab:			Tktab;		// kurzzeittimer
		bm:			tbitmap;
		dini: tinifile;
		tv:			ttreenode;
	end;
	ptmbswork = ^tmbswork;

implementation

uses mbs_u, mbs_anl_u, mbs_bea_u, mbs_ver_u, mbs_weg_u,
	mbs_col_u, mbs_uhr_u, mbs_cnt, mbs_mon_u,
	mbs_amp, mbs_stp, mbs_lck, mbs_aus, mbs_non, mbs_hsi,
	mbs_vsi, mbs_trn, mbs_fst;

//{$R *.DFM}

const
	fkey = 'Feld_%3.3d_%3.3d';
	skey = 'Verb%d=d%3.3d,%3.3d,%3.3d,%3.3d';

var
	mw:			ptmbswork;
	bm,
	bmn,
	bmo,
	bmw,
	bmv:			TBitmap;
	znum:			byte;

function Tmbs_fld.getz: ptfeld;
begin
	result := addr(f);
end;

procedure Tmbs_fld.SetPos(value: tpoint);
begin
	f.Posx := value.x;
	f.Posy := value.y;
end;

function Tmbs_fld.GetPos: tpoint;
begin
	result.x := f.Posx;
	result.y := f.Posy;
end;

procedure Tmbs_fld.setstr;
{
var
	i:			integer;
}
begin
{
	for i := 0 to 3
	do begin
		if F.Ad[0].m[0, i] <> leer
		then f.Mstr[i] := char($80 + f.ad[0].c)
							+ char(F.Ad[0].m[i] shl 4 + f.ad[0].v)
		else f.Mstr[i] := '';
	end;
	f.Pstr := '';
	if f.ad[0].c > 0
	then begin
		mw.dtab[f.ad[0].c].f[f.ad[0].v] := self;
		for i := 0 to 3
		do begin
			p := GetDpar(i);
//			if f.Parm[i] <> leer
			if p > leer
			then f.Pstr := f.Pstr
							+ char($80 + f.ad[0].c)
							+ char(i shl 4 + f.ad[0].v)
							+ char(p);
		end;
	end;
}
end;

function Tmbs_fld.bwdir(rpz: byte): byte;
begin
	result := 0;
	case rpz of
	1:  	result := 56;
	2:  	result := 112;
	4:  	result := 224;
	8:  	result := 193;
	16:  	result := 131;
	32: 	result := 7;
	64: 	result := 14;
	128:	result := 28;
	end;
end;

function Tmbs_fld.fwdir(rpz: byte): byte;
begin
	result := 0;
	case rpz of
	1:  	result := 131;
	2: 	result := 7;
	4: 	result := 14;
	8:		result := 28;
	16:  	result := 56;
	32:  	result := 112;
	64:  	result := 224;
	128: 	result := 193;
	end;
end;

procedure Tmbs_fld.putcom;
var
	i:			integer;
begin
	if f.Stat < belp
	then begin
		for i := 0 to 3
		do begin
//**			if f.adrt[i].po < 5
			if mw.dtab[f.adrt[i].dc].c < 5
			then begin
				if (f.adrt[i].dc > 0)
				and (f.adrt[i].ms[f.stat] <> leer)
				then begin
					mbs_f.pt[mw.dtab[f.adrt[i].dc].c].SendCom(
									f.adrt[i].dc,
									f.adrt[i].dv,
									f.adrt[i].ms[stat]);
				end;
			end;
		end;
	end;
end;

procedure Tmbs_fld.putpar;
var
	i:			integer;
	p:			byte;
	dc:		word;
	dv:		byte;
begin
	for i := 0 to 3
	do begin
		dc := f.adrt[i].dc;
		if dc = 0
		then continue;
		dv := f.adrt[i].dv;
		if not mbs_bea_f.iniset(dc, dv, true)
		then begin
			if mw.styp = 'srv'
			then begin
				p := mw.dini.ReadInteger(mw.sdev, 'swf', 0)
					+ mw.dini.ReadInteger(mw.sdev, 'phi', 4);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 0, p);
				p := mw.dini.ReadInteger(mw.sdev, 'dif', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 1, p);
				p := mw.dini.ReadInteger(mw.sdev, 'krz', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 2, p);
				p := mw.dini.ReadInteger(mw.sdev, 'lng', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 3, p);
			end;
			if mw.styp = 'out'
			then begin
				p := mw.dini.ReadInteger(mw.sdev, 'ach', 1)
					+ mw.dini.ReadInteger(mw.sdev, 'non', 0)
					+ mw.dini.ReadInteger(mw.sdev, 'nof', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 0, p);
				p := mw.dini.ReadInteger(mw.sdev, 'ont', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 1, p);
				p := mw.dini.ReadInteger(mw.sdev, 'oft', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 2, p);
				p := mw.dini.ReadInteger(mw.sdev, 'ndv', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 3, p);
			end;
			if mw.styp = 'amp'
			then begin
				p := mw.dini.ReadInteger(mw.sdev, 'tim', 0);
				mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 1, p);
			end;
		end;
	end;
end;

// fr bearbeiten von servos
procedure Tmbs_fld.puttst(
	dev: byte;
	par: tpar;
	sta: tsta);
var
	p:			byte;
	dc:		word;
	dv:		byte;
begin
	if mw.mode <> 1
	then exit;
	dc := f.adrt[dev].dc;
	if dc = 0
	then exit;
	dv := f.adrt[dev].dv;
	mw.sdec := format('Decoder%3.3d', [dc]);
	mw.sdev := format('dev%2.2d', [dv]);
	mw.sdev := mw.dini.ReadString(mw.sdec, mw.sdev, '');
	if mw.sdev = ''
	then mw.sdev := 'send*';

	case par of
	par0:
		begin
			p := mw.dini.ReadInteger(mw.sdev, 'inv', 0)
				+ mw.dini.ReadInteger(mw.sdev, 'swf', 0)
				+ mw.dini.ReadInteger(mw.sdev, 'phi', 1);
			mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 0, p);
		end;
	par1:
		begin
			p := mw.dini.ReadInteger(mw.sdev, 'dif', 0);
			mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 1, p);
		end;
	par2:
		begin
			p := mw.dini.ReadInteger(mw.sdev, 'krz', 0);
			mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 2, p);
		end;
	par3:
		begin
			p := mw.dini.ReadInteger(mw.sdev, 'lng', 0);
			mbs_f.pt[mw.dtab[dc].c].sendpar(dc, dv, 3, p);
		end;
	end;
end;

procedure Tmbs_fld.kreuz(var b: TBitmap; c: TColor);
const
	lg = 3;
begin
	b := TBitMap.Create;
	b.Width := gr + 1;
	b.Height := gr + 1;
	with b.Canvas
	do begin
		brush.Color := c;
		fillrect(re);
		pen.Width := 1;
		pen.Color := clgray;
		moveto(0, lg - 1);
		lineto(0, 0);
		lineto(lg, 0);
		moveto(gr - lg + 1, 0);
		lineto(gr, 0);
		lineto(gr, lg);
		moveto(gr, gr - lg + 1);
		lineto(gr, gr);
		lineto(gr - lg, gr);
		moveto(lg - 1, gr);
		lineto(0, gr);
		lineto(0, gr - lg);
  end;
end;

constructor Tmbs_fld.Createxy(AOwner: TComponent;
//					sb: tstatusbar;
					x, y: byte);
var
	i:			integer;
begin
	mw := ptmbswork(application.tag);
	inherited create(AOwner);

	if not assigned(bmo)
	then begin
		kreuz(bm, clsilver);
		kreuz(bmn, clteal);
		kreuz(bmo, clsilver);
		kreuz(bmw, clwhite);
		kreuz(bmv, clfuchsia);
		mw.bm := bm;
	end;
	Name := format(fkey, [x, y]);
//	FImag := TImage(AOwner);
	F.Stat := sta0;
	F.Stan := 1;
	for i := 0 to fvlstm
	do begin
		F.Vlst[i].x := 0
	end;
	F.Posx := x;
	F.Posy := y;

end;

procedure Tmbs_fld.SetFTyp(Value: TFTyp);
begin
	F.FTyp := Value;
	setstab;
end;

procedure Tmbs_fld.SetStab;
var
	si:		tsta;
begin
	for si := sta0 to sta7
	do begin
		F.stab[si] := 0;
	end;
	case F.FTyp of
	ftNon:	fnon.setstab(self);
	ftAus:	faus.Setstab(self);
	ftGls:	fnon.setstab(self);
	ftTrn,
	ft3wg,
	ftEkw,
	ftDkw:	ftrn.setstab(self);
	ftHsi:	fhsi.setstab(self);
	ftVsi:	fvsi.setstab(self);
	ftGkt:	fcnt.setstab(self);
	ftLck:	flck.setstab(self);
	ftFst:	ffst.setstab(self);
	ftDrs:	; //fdrs.setstab;
	ftBrk,
	ftEnd:	fnon.setstab(self);
	ftStr:	fnon.setstab(self);
	ftAbz:	ftrn.setstab(self);
	ftStp:	fstp.setstab(self);
	ftSkt:	fcnt.setstab(self);
	ftAmp:	famp.SetStab(self);
	ftSte:	fnon.setstab(self);
	fty1:		;
	end;
end;

procedure Tmbs_fld.SetZugn(Value: byte);
begin
	F.Zugn := Value;
{	if F.FTyp = ftLck
	then begin
		if F.Zugn > 0
		then putcom(5)
		else putcom(4);
		paint(0);
	end;
}
end;

procedure Tmbs_fld.SetZugw(Value: byte);
begin
	F.Zugw := Value;
end;

procedure Tmbs_fld.SetConn(Value: byte);
begin
	F.Conn := Value;
	if F.Conn = 0
	then begin
//		FTyp := ftNon;
		F.Isol := 0;
	end;
	if (F.Isol = 0)
	and ((FTyp = ftHsi) or (FTyp = ftVsi))
	then FTyp := ftNon;
	if FTyp = ftVsi
	then F.Conn := F.Conn or F.Isol;
	setstab;
end;

procedure Tmbs_fld.SetIsol(Value: byte);
begin
	F.Isol := Value;
	if (F.Isol = 0)
	and ((FTyp = ftHsi) or (FTyp = ftVsi))
	then FTyp := ftNon;
	if FTyp = ftVsi
	then F.Conn := F.Conn or F.Isol;
	setstab;
end;

procedure Tmbs_fld.SetMess(ind: byte; m: array of byte);
var
	i:			tsta;
begin
	for i := sta0 to tsta(high(m))
	do begin
		if i < tsta(F.Stan)
		then F.Adrt[ind].ms[i] := m[byte(i)]
		else F.Adrt[ind].ms[i] := leer;
	end;
//	setstr;
end;

procedure Tmbs_fld.SetMess(ind: byte; sta: tsta; m: byte);
begin
	F.Adrt[ind].ms[sta] := m;
end;

{procedure Tmbs_fld.SetDpar(ind: byte; par: tpar; val: byte);
begin
	mw.dtab[f.adrt[ind].dc].p[f.adrt[ind].dv, byte(par)] := val;
end;
}

procedure Tmbs_fld.SetIpar(par: tpar; val: byte);
begin
	f.parm[par] := val;
end;

procedure Tmbs_fld.SetAd(index: byte; value: tmbs_adr);
begin
	f.adrt[index].dc := value.dc;
	f.adrt[index].dv := value.dv;
	f.adrt[index].ms := value.ms;
end;

function Tmbs_fld.GetAd(index: byte): tmbs_adr;
begin
	result := f.adrt[index];
//**	result.po := mw.dtab[f.adrt[index].dc].c;
end;

{function Tmbs_fld.GetDpar(ind: byte; par: tpar): byte;
begin
	if f.adrt[ind].dc > 0
	then result := mw.dtab[f.adrt[ind].dc].p[f.adrt[ind].dv, byte(par)]
	else result := leer;
end;
}

function Tmbs_fld.GetIpar(par: tpar): byte;
begin
	result := f.parm[par]
end;

function Tmbs_fld.GetStat(): tsta;
begin
	if mw.mode > 0
	then result := F.Vsta
	else result := F.Stat;
end;

procedure Tmbs_fld.DoVerb(stat: tsta);
var
	v:			Tmbs_vrb;
	d:			byte;
begin
	fdoverb := true;
	for d := 0 to fvlstm
	do begin
		v := F.Vlst[d];
		if (v.x > 0)
		and (v.wst = stat)
		then begin
			case v.fix of
// 124 add verb ktimer setstat
// 127 add verb ktimer nextstat
			124, 127:	// kurzzeittimer param next/stat
					mbs_uhr_f.addktimer(mw.ftab[v.x, v.y],
								v.rpz, v.sst);
// 125 add verb ktimer:par setstat
// 126 add verb ktimer:par nextstat
			125, 126:	// kurzzeittimer param next/stat
					mbs_uhr_f.addktimer(mw.ftab[v.x, v.y],
								f.parm[tpar(v.rpz)], v.sst);
			else
				begin
					case v.sst of
					sstl:
						begin
// fix add verb fix next
							mw.ftab[v.x, v.y].NextStat;
//							mw.ftab[v.x, v.y].paint(0);
						end;
					else
						begin
// fix add verb fix stat
							mw.ftab[v.x, v.y].Stat := tsta(v.sst);
//						mw.ftab[v.x, v.y].paint(0);
						end;
					end;
				end;
			end;
			if mbs_mon_f.v1.checked
			then begin
				anzverb(mbs_mon_f.lb, d, v);
			end;
		end;
	end;
end;

// bel heisst nur ndern wenn bel=0
procedure Tmbs_fld.setstatcom(value: tsta);
begin;
	if mw.run
	and not fdoverb
	then begin
		F.Stat := Value;
		F.Vsta := Value;
		if mw.mode = 0
		then begin
			doverb(f.stat);
			fdoverb := false;
			putcom;
		end;
		paint(mw.mode);
	end;
end;

procedure Tmbs_fld.SetBlgt(Value: byte);
begin
	if mw.run
	and not fdoverb
	then begin
	end;
end;

procedure Tmbs_fld.RecMess(Value: boolean);
begin
	case f.FTyp of
	ftamp: 	famp.RecMess(self, value);
	ftlck:	flck.RecMess(self, value);
	end;
end;

procedure Tmbs_fld.SetStat(Value: tsta);
begin
	if not assigned(self)
	then exit;
	if mw.mode > 0
	then begin
		F.Vsta := Value;		// mod F.Stan;
		exit;
	end;
	if (F.Zugn > 0)
	and (ftyp <> ftaus)		//, ftgkt, ftskt])
	then exit;
	if value = F.Stat
	then exit;
	case F.FTyp of
// nix tun
	ftNon,
	ftGls,
	ftStr:	;
// nix tun wenn belegt
	ft3wg,
	ftEkw,
	ftDkw,
	ftTrn,
	ftAbz:	ftrn.SetStat(self, value);
	ftHsi:   fhsi.SetStat(self, value);
	ftVsi:	fvsi.SetStat(self, value);
	ftfst:	ffst.SetStat(self, value);
// tun
	ftAmp:	famp.SetStat(self, value);
	ftLck:	flck.SetStat(self, value);
	ftStp:	fstp.Setstat(self, value);
	ftAus:	faus.SetStat(self, value);
	ftSkt,
	ftGkt:	fcnt.SetStat(self, value);
	end;
end;

procedure Tmbs_fld.DrawConn(f, pw1, pw2: byte);
begin
	with bm.Canvas
	do begin
		Pen.Width := pw1;
		if con and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(gr2, 0);
		end;
		if coo and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(gr, gr2);
		end;
		if cos and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(gr2, gr);
		end;
		if cow and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(0, gr2);
		end;
		Pen.Width := pw2;
		if cono and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(gr, 0);
		end;
		if coso and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(gr, gr);
		end;
		if cosw and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(0, gr);
		end;
		if conw and f > 0
		then begin
			moveto(gr2, gr2);
			lineto(0, 0);
		end;
	end;
end;

procedure Tmbs_fld.paint(Mode: byte);
const
	fset: set of ftnon..ftype =
			[ftnon, ftgls, ftstr, ftend,
			ftste, ftfst];
var
	pos:		TPoint;
//	sta:		tsta;
begin
	if not assigned(self)
	then exit;
//	if mode > 0
//	then sta := F.Vsta
//	else sta := F.Stat;
	pos.x := F.Posx * gr - gr;
	pos.y := F.Posy * gr - gr;
	with bm.canvas
	do begin
		case mode of
		0: CopyRect(re, bmo.Canvas, re);
		1: begin
				if not(f.FTyp in fset)
//				or (f.adrt[0].dc > 0)
				then CopyRect(re, bmw.Canvas, re)
				else CopyRect(re, bmn.Canvas, re);
			end;
		2: CopyRect(re, bmv.Canvas, re);
		9: begin
				if (f.FTyp in fset)
				or (f.adrt[0].dc > 0)
				then CopyRect(re, bmo.Canvas, re)
				else CopyRect(re, bmn.Canvas, re);
			end;
		end;
		if F.FTyp <> ftNon
		then begin
			Pen.Color := clblack;
			if F.Blgt > 0
			then begin
				Pen.Color := clblue;
				if f.ftyp = ftbrk
				then drawconn(F.Conn, 7, 5)
				else drawconn(F.Conn, 7, 2);
			end
			else begin
				if F.FTyp >= ftStr
				then pen.color := clgray
				else pen.color := clblack;
				if f.ftyp = ftbrk
				then drawconn(F.Conn, 3, 5)
				else drawconn(F.Conn, 3, 2);
			end;
		end;
		case F.FTyp of
		ftLck:	flck.draw(self);
		ftAmp:	famp.draw(self);
		ftStp:	fstp.draw(self);
		ftAus:   faus.draw(self);
		ftgkt,
		ftskt:	fcnt.draw(self);
		ftFst:	ffst.draw(self);
		ftSte,
		ftEnd:	fnon.draw(self);
		ftHsi:   fhsi.draw(self);
		ftVsi:	fvsi.draw(self);
		ftTrn,
		ftAbz,
		ft3wg,
		ftdkw,
		ftekw:	ftrn.draw(self);
		ftgls:	;
		end;
		if F.Posx < mw.trenn
		then begin
			mw.i1.canvas.Draw(pos.x, pos.y, bm);
		end
		else begin
			pos.x := pos.x - (mw.trenn - 1) * gr;
			mw.i2.canvas.Draw(pos.x, pos.y, bm);
		end;
	end;
end;

procedure Tmbs_fld.Copy(vf: Tmbs_fld);
var
	x,
	y:			integer;
begin
	x := f.Posx;
	y := f.Posy;
	F := vf.F;
	f.posx := x;
	f.posy := y;
end;

procedure Tmbs_fld.AddVerb(v: Tmbs_vrb);
var
	i:			integer;
begin
	delverb(v);
	for i := 0 to fvlstm
	do begin
		if F.Vlst[i].x = 0
		then begin
			F.Vlst[i] := v;
			break;
		end;
	end;
end;

procedure Tmbs_fld.AddVerb(f: Tmbs_fld; sst: tsst);
var
	v:			Tmbs_vrb;
begin
	v.x := f.x;
	v.y := f.y;
	v.wst := f.Stat;
	v.sst := sst;
	AddVerb(v);
end;

procedure Tmbs_fld.DelVerb(f: Tmbs_fld; sst: tsst);
var
	v:			Tmbs_vrb;
begin
	v.x := f.x;
	v.y := f.y;
	v.wst := f.Stat;
	v.sst := sst;
	DelVerb(v);
end;

procedure Tmbs_fld.DelVerb(v: Tmbs_vrb);
var
	i:			integer;
begin
	for i := 0 to fvlstm
	do begin
		if (F.Vlst[i].x = v.x)
		and (F.Vlst[i].y = v.y)
		and (F.Vlst[i].wst = v.wst)
		then begin
			F.Vlst[i].wst := sta0;
			F.Vlst[i].x := 0;
			F.Vlst[i].y := 0;
			break;
		end;
	end;
end;

procedure Tmbs_fld.DelVerb(fix: boolean);
var
	i:			integer;
begin
	for i := fvlstm downto 0
	do begin
		if not fix
		then begin
			if F.Vlst[i].fix = 0
			then delverb(F.Vlst[i]);
		end
		else begin
			if F.Vlst[i].fix > 0
			then delverb(F.Vlst[i]);
		end;
	end;
end;

procedure Tmbs_fld.CngVerb(p1, p2: tpoint);
var
	i:			integer;
begin
	if f.Posx = 38
	then mbs_weg_f.Caption := inttostr(p1.y);
	for i := 0 to fvlstm
	do begin
		if (F.Vlst[i].x = p1.x)
		and (F.Vlst[i].y = p1.y)
		then begin
			F.Vlst[i].x := p2.x;
			F.Vlst[i].y := p2.y;
			continue;
		end;
		if (F.Vlst[i].x = p2.x)
		and (F.Vlst[i].y = p2.y)
		then begin
			F.Vlst[i].x := p1.x;
			F.Vlst[i].y := p1.y;
		end;
	end;
end;

procedure Tmbs_fld.CngVerb(ber: trect;
				difx, dify: byte);
var
	i:			integer;
begin
	for i := fvlstm downto 0
	do begin
		if F.Vlst[i].x = 0
		then continue;
		if (F.Vlst[i].x >= ber.Left)
		and (F.Vlst[i].x <= ber.Right)
		and (F.Vlst[i].y >= ber.Top)
		and (F.Vlst[i].y <= ber.Bottom)
		then begin
			if (difx <> 0)
			or (dify <> 0)
			then begin
				inc(F.Vlst[i].x, difx);
				inc(F.Vlst[i].y, dify);
			end
			else delverb(F.Vlst[i]);
		end;
	end;
end;

procedure Tmbs_fld.FstVerb;
begin
	fVind := 0;
end;

function	Tmbs_fld.GetVerb(var v: Tmbs_vrb): boolean;
begin
	result := false;
	while (FVind <= fvlstm)
	do begin
		if (F.Vlst[FVind].x > 0)
		then begin
			v := F.Vlst[FVind];
			result := true;
			inc(FVind);
			exit;
		end;
		inc(FVind);
	end;
end;

function	Tmbs_fld.GetVerbStr(
			var vrb: Tmbs_vrb;
			var str: string;
			var ind: byte): boolean;
begin
	result := false;
	while (FVind <= fvlstm)
	do begin
		if (F.Vlst[FVind].x > 0)
		then begin
			vrb := F.Vlst[FVind];
			str := (format('%3.3d:%3.3d=%x (%d)',
						[F.Vlst[fvind].x,
						F.Vlst[fvind].y,
						byte(F.Vlst[fvind].sst),
						fvind]));
			ind := FVind;
			inc(FVind);
			result := true;
			exit;
		end;
		inc(FVind);
	end;
end;

function	Tmbs_fld.GetVerb(
		var v: Tmbs_vrb;
		ind: byte): boolean;
begin
	result := false;
	if (F.Vlst[ind].x > 0)
	then begin
		v := F.Vlst[ind];
		result := true;
	end;
end;

function	Tmbs_fld.FndVerb(v: Tmbs_vrb): boolean;
var
	i:			integer;
begin
	result := false;
	for i := 0 to fvlstm
	do begin
		if (F.Vlst[i].x = v.x)
		and (F.Vlst[i].y = v.y)
		and (F.Vlst[i].wst = v.wst)
		then result := true;
	end;
end;

procedure Tmbs_fld.ShwVerb(lb: TListBox);
var
	i:			integer;
begin
	lb.clear;
	lb.Sorted := false;
	for i := 0 to fvlstm
	do begin
		if F.Vlst[i].x > 0
		then lb.items.AddObject(format('Verb%d_%3.3d_%3.3d=%2.2x',
						[byte(F.Vlst[i].wst),
						F.Vlst[i].x,
						F.Vlst[i].y,
						byte(F.Vlst[i].sst)]),
						tobject(i));
	end;
	lb.Sorted := true;
end;

procedure Tmbs_fld.ShwVerb(lb: TListBox; sta: tsta);
var
	i:			integer;
begin
	lb.clear;
	lb.Sorted := false;
	for i := 0 to fvlstm
	do begin
		if (F.Vlst[i].x > 0)
		and (F.Vlst[i].wst = sta)
		then lb.items.AddObject(format('Verb%d_%3.3d_%3.3d=%2.2x',
						[byte(F.Vlst[i].wst),
						F.Vlst[i].x,
						F.Vlst[i].y,
						byte(F.Vlst[i].sst)]),
						tobject(i));
	end;
	lb.Sorted := true;
end;

procedure Tmbs_fld.NextStat;
begin
	if F.Stan = 0
	then F.Stan := 1;
	if mw.mode > 0
	then F.Vsta := tsta((byte(F.Vsta) + 1) mod F.Stan)
	else Stat := tsta((byte(F.Stat) + 1) mod F.Stan);
end;

function Tmbs_fld.GetWurz: byte;
begin
	result := F.Stab[sta7];
end;

function Tmbs_fld.GetStab: byte;
begin
	if mw.mode > 0
	then result := F.Stab[F.Vsta]
	else result := F.Stab[F.Stat];
end;

function Tmbs_fld.Next(rpz: byte): byte;
var
	e:			byte;
begin
	e := (rpz shl 4) or (rpz shr 4); 					// eintritt
	case F.FTyp of
	ftTrn:
		if (F.Stab[F.Stat] and e) > 0
		then result := F.Stab[F.Stat] and (255 - e)
		else result := 255;
	ftHsi:
		if (e and F.Isol) > 0
		then result := 0
		else result := F.Isol;
	else
		result := F.Conn and (255-e);
	end;
end;

function Tmbs_fld.Next2(rpz: byte): byte;
var
	e:			byte;
begin
	e := (rpz shl 4) or (rpz shr 4); 					// eintritt
	case F.FTyp of
	ftTrn:
		if (F.Stab[F.Stat] and e) > 0
		then result := F.Stab[F.Stat] and (255 - e)
		else result := 255;
	else
		result := (F.Conn or F.Isol) and (255-e);
	end;
end;

procedure nextverb(var verb: Tmbs_vrb);
begin
	case verb.rpz of
	con:	begin 					dec(verb.y);	end;
	cono:	begin	inc(verb.x);	dec(verb.y);	end;
	coo:	begin	inc(verb.x);						end;
	coso:	begin	inc(verb.x);	inc(verb.y);	end;
	cos:	begin						inc(verb.y);	end;
	cosw:	begin	dec(verb.x);	inc(verb.y);	end;
	cow:	begin	dec(verb.x);						end;
	conw:	begin	dec(verb.x);	dec(verb.y);	end;
	end;
end;

function Tmbs_fld.Bel_Pos(var verb: Tmbs_vrb; start: boolean): boolean;
var
	m:			integer;
	v:			Tmbs_vrb;
	n:			Tmbs_fld;
begin
	m := fwdir(verb.rpz);					// eintritt
	case F.FTyp of
	ftTrn:
		begin
			if (F.Stab[F.Stat] and m) > 0
			then begin
				verb.rpz := F.Stab[F.Stat] and m;
				nextverb(verb);
				F.Zugn := F.Zugn or 128;
				result := true;
			end
			else begin
				verb.rpz := 0;
				result := false;
			end;
		end;
	ftHsi:
		begin
			if start
			then begin
				v := verb;
				v.rpz := F.Conn;
				nextverb(v);
				n := mw.ftab[v.x, v.y];
				if n.FTyp = ftgkt
				then begin
					v := verb;
					v.wst := sta0;
					v.sst := sst1;
					n.AddVerb(v);
				end;
			end;

			if (F.Stat > sta0)
			or start
			then verb.rpz := (F.Conn or F.Isol) and m
			else verb.rpz := F.Conn and m;
			nextverb(verb);
			F.Zugn := F.Zugn or 128;
			result := true;
		end;
	else
		begin
			verb.rpz := F.Conn and m;
			nextverb(verb);
			F.Zugn := F.Zugn or 128;
			result := true;
		end;
	end;
end;

//ja
function Tmbs_fld.Nxt_Pos(var rpz: byte): Tmbs_fld;
var
	m:			integer;
	v:			Tmbs_vrb;
begin
	m := fwdir(rpz);					// eintritt
	v.x := F.Posx;
	v.y := F.Posy;
	case F.FTyp of
	ftEnd:
		begin
			v.x := F.vlst[0].x;
			v.y := F.vlst[0].y;
			if v.x > 0
			then begin
				v.rpz := mw.ftab[v.x, v.y].Conn;
				result := mw.ftab[v.x, v.y];
			end
			else begin
				v.rpz := 0;
				result := nil;
			end;
		end;
	ftTrn:
		begin
			if (F.Stab[F.Stat] and m) > 0
			then begin
				v.rpz := F.Stab[F.Stat] and m;
				nextverb(v);
				result := mw.ftab[v.x, v.y];
			end
			else begin
				v.rpz := 0;
				result := nil;
			end;
		end;
	else
		begin
			v.rpz := (F.Conn or F.Isol) and m;
			nextverb(v);
			if v.rpz = 0
			then result := nil
			else result := mw.ftab[v.x, v.y];
		end;
	end;
	rpz := v.rpz;
end;

function Tmbs_fld.beleg(rpz, zug: byte; cont, vsig: Tmbs_fld): boolean;
var
	d:			byte;
	n:			Tmbs_fld;
	e: 		boolean;
begin
	d := rpz;
	result := true;
	n := Nxt_Pos(d);
	if F.FTyp = ftgkt
	then cont := Self;
	if F.FTyp = ftVsi
	then vsig := Self;
	if assigned(n)
	then begin
		if (n.ftyp = ftHsi)		// Signal
		then begin
			n.zugw := zug; 		// belegung signal ok
			F.Zugn := zug;
			if assigned(Cont)
			then cont.AddVerb(n, sst0);  // belegung contakt ok
			if assigned(vsig)
			then n.AddVerb(vsig, sst0);  // belegung contakt ok
			result := true;
			exit;
		end;
		if n.Zugn = 0 					// frei
		then begin
			e := n.beleg(d, zug, cont, vsig);
			if e
			then begin
{ TODO : wenn schranke offen, dann verb zu HS
				eintragen und bei zu neuerlich grn stellen
				belgungszhler F.Stab[3]
				andere schranke!!}
				self.Zugn := zug;
			end;
			result := e;
		end
		else begin
			result := (n.Zugn = zug);
		end;
	end;
end;

procedure Tmbs_fld.freig(rpz, zug: byte; cont: boolean);
var
	d:			byte;
	n:			Tmbs_fld;
begin
	d := rpz;
	n := Nxt_Pos(d);
	if assigned(n)
	and (n.Zugn > 0)
	then begin
		if zug = n.Zugn 					// freigeben
		then begin
			if n.FTyp = ftgkt
			then begin
				if cont
				then n.zugn := 0;
			end
			else n.zugn := 0; 					// ok
			n.freig(d, zug, cont);
		end;
	end;
end;

procedure Tmbs_fld.Mouseup();
begin
	if mw.mode > 0
	then exit;
	if (F.FTyp = ftaus)
	then begin
		if getIpar(par0) > 0
		then stat := sta0;
	end;
//	if (f.ftyp = ftfst)
//	and (mw.mode = 0)
//	then setstat(sta0);
end;

procedure Tmbs_fld.Mousedown(i: timage;
					b: tmousebutton);
var
	p:			TPoint;
begin
	if znum > 0
	then begin
//		ztab[znum].x := F.Posx;
//		ztab[znum].y := F.Posy;
		F.Zugn := znum;
		znum := 0;
		mbs_uhr_f.inf2.Caption := '';
	end;
	p := i.ClientToScreen(Point(x * gr, y * gr));
	case mw.mode of
	0: // fahren
		begin
			if assigned(mw.w)
			then mw.w.paint(0);
			mw.w := self;
			if b = mbleft
			then begin
				case mw.w.FTyp of
{ TODO : nur fr test }
//----------------------------
				ftAmp:	famp.ChngStat;
{ TODO : nur fr test }
//----------------------------
				ftLck:	flck.ChngStat;
				ftStp:	fstp.ChngStat;
				ftAus:	faus.ChngStat;
				ftGkt,
				ftSkt:	fcnt.ChngStat;
				ftFst:   ffst.ChngStat;
				ftTrn,
				ftAbz,
				ft3wg,
				ftdkw,
				ftekw:	ftrn.ChngStat;
				ftVsi: 	fvsi.ChngStat;
				ftHsi:	fhsi.ChngStat;
{ TODO : nur fr test }
//----------------------------
				end;
			end
			else begin
				if mw.w.zugn > 0
				then begin
//					mbszugf.num.Caption := inttostr(mw.w.zugn);
//					mbszugf.spd.Tag := mw.w.zugn;
//					mbszugf.spd.Position := ztab[mw.w.Zugn].Spd;
//					mbszugf.spdl.Caption := inttostr(mbszugf.spd.Position * -1);
				end
				else begin
					if mw.w.FTyp = ftGls
					then begin
						if mw.w.Zugn = 0
						then begin
//							mbsextf.zugpm.Tag := mw.w.Zugn;
							p := i.ClientToScreen(Point(x, y));
//							mbsextf.zugpm.Popup(p.x, p.y);
						end;
					end;
				end;
			end;
			mw.w.paint(0);
//			mbs_uhr_f.putinf(self);
		end;
	1: // bearbeiten
		mbs_bea_f.beaMousedown(self, b);
	2: // verbinden
		mbs_ver_f.verMousedown(self, b);
	3: // wege
		mbs_weg_f.wegMousedown(self, b);
	4: // anlage
		mbs_anl_f.anlMousedown(self, b);
	end;
//	mbs_uhr_f.putinf(mw.w);
end;

procedure Tmbs_fld.HSiChange(p: tpoint);
begin
{	if not assigned(mw.w)
	then exit;
	mbsextf.hsipm.Tag := mw.w.Stat;
	mbsextf.msig6.enabled := (mw.w.stan > 2);
	mbsextf.msig4.enabled := (mw.w.stan > 3);
	mbsextf.hsipm.Popup(p.x, p.y);
	application.ProcessMessages;
	if mbsextf.hsipm.Tag <> mw.w.Stat
	then begin
		origstat(mbsextf.hsipm.tag);
		if (mw.w.Stat = mbsextf.hsipm.tag)
		and (mbsextf.hsipm.tag > 0)
		then setstr;
	end;
}end;

procedure Tmbs_fld.hsisetstate(f: Tmbs_fld; Value: tsta);
begin
{	if Value mod F.Stan = 0
	then F.Conn := F.Conn and (255 xor F.Isol)
	else F.Conn := F.Conn or F.Isol;
	if value mod F.Stan = 0
	then begin
//				delverb(v);
//				freig(F.Conn, F.Zugw, true);
		F.Zugn := 0;
		F.Stat := Value mod F.Stan;
	end
	else begin
		if beleg(F.Isol, F.Zugw, nil, nil)
		then begin
			F.Stat := Value mod F.Stan;
//					F.Zugn := w.zugw;
		end
		else exit;
	end;
}end;

procedure Tmbs_fld.SaveFeld(var fi: file);
var
	h:			THead;
begin
	h.leng := safld + sizeof(f);
	h.Posx := F.posx;
	h.Posy := f.posy;
	if (f.Conn = 0)
	and ((f.FTyp = ftgls)
		or (f.FTyp = ftstr))
	then f.FTyp := ftnon;
	blockwrite(fi, h, sizeof(h));
	blockwrite(fi, f, sizeof(f));
end;

procedure Tmbs_fld.LoadFeld(var fi: file; lng: integer);
begin
	blockread(fi, f, lng);
end;

function bol(b: boolean): string;
begin
	if b
	then result := 'true'
	else result := 'false';
end;

function bin(b: byte): string;
var
	i:			integer;
	s:			array[0..7] of char;
begin
	for i := 7 downto 0
	do begin
		s[i] := char((b shr i and 1) + 48);
	end;
	result := s;
end;

procedure Tmbs_fld.Anzeige(lb: tlistbox; num: byte);
var
	i:			integer;
	j:			tsta;
begin
	lb.Clear;
	lb.items.Add(format('FTyp: %s PTyp: %s',
				[sftab[integer(f.ftyp)]
				,sptab[integer(f.ptyp)]
				]));
	lb.items.Add(format('Pos:  %d %d',
				[f.posx, f.posy]));
	lb.items.Add(format('Conn: %s Isol: %s',
				[bin(f.conn), bin(f.isol)]));
	lb.items.Add(format('Stat: %d  VSta: %d  Stan: %d',
				[byte(f.stat), byte(f.vsta), byte(f.stan)]));
	lb.items.Add(format('Stab: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x',
				[f.stab[sta0], f.stab[sta1],
				f.stab[sta2], f.stab[sta3],
				f.stab[sta4], f.stab[sta5],
				f.stab[sta6], f.stab[sta7]]));
	lb.items.Add(format('Blgt: %d Zugn: %d Zugw: %d',
				[f.blgt, f.zugn, f.zugw]));
	lb.items.Add(format('Farb: %x %x',
				[f.farb shr 4, f.farb and $0f]));
	lb.items.Add(format('Ipar: %3d %3d %3d %3d',
				[GetIpar(par0), GetIpar(par1),
				GetIpar(par2), GetIpar(par3)]));
	for i := 0 to 3
	do begin
		if F.Adrt[i].dc > 0
		then begin
			lb.items.Add(format('Dec%d: %s %d %d',
				[i + 1,
				char(mw.dtab[f.Adrt[i].dc].c + 64),
				f.adrt[i].dc,
				f.adrt[i].dv]));
			lb.items.Add(format(
				'Mes%d: %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x %2.2x',
				[i + 1,
				F.Adrt[i].ms[sta0], F.Adrt[i].ms[sta1],
				F.Adrt[i].ms[sta2], F.Adrt[i].ms[sta3],
				F.Adrt[i].ms[sta4], F.Adrt[i].ms[sta5],
				F.Adrt[i].ms[sta6], F.Adrt[i].ms[sta7]]));
		end;
	end;
	for j := sta0 to belm
	do begin
		for i := 0 to fvlstm
		do begin
			if (f.Vlst[i].x > 0)
			and (f.Vlst[i].wst = j)
			then begin
				anzverb(lb, i, f.Vlst[i]);
			end;
		end;
	end;
end;

procedure Tmbs_fld.AnzVerb(lb: tlistbox; d: byte; v: Tmbs_vrb);
var
	s:			string;
begin
	if (v.x = f.Posx)
	and (v.y = f.Posy)
	then s := format(ve,
			[d, v.fix, ord(v.wst)])
	else s := format(vf,
			[d, v.fix, ord(v.wst),
			v.x, v.y]);
	case v.fix of
// 120 add verb sub beleg
//				120:	lb.items.Add(s + '=-bel');
// 121 add verb add beleg
//				121:	lb.items.Add(s + '=+bel');
// 124 add verb ktimer setstat
	124:	lb.items.Add(s + format('(%d)=$%2.2x', [
						v.rpz,
						ord(v.sst)]));
// 125 add verb ktimer:par setstat
	125:	lb.items.Add(s + format('(P%d)=$%2.2x', [
						v.rpz,
						ord(v.sst)]));
// 126 add verb ktimer:par nextstat
	126:	lb.items.Add(s + format('(P%d)=+', [
						ord(v.rpz)]));
// 127 add verb ktimer nextstat
	127:	lb.items.Add(s + format('(%ds)=+', [
						v.rpz]));
	else
		if v.sst <> sstl
// fix add verb fix stat
		then lb.items.Add(s + format('=$%2.2x', [
						ord(v.sst)]))
// fix add verb fix next
		else lb.items.Add(s + '=+');
	end;
end;

end.


