unit mbs_lck;

interface

uses
  	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, Menus, StdCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfLck =
	class(TForm)
		par: TGroupBox;
		pin: Tmbs_led;
		lmin: TLabel;
		min: Tmbs_epd;
		lmax: TLabel;
		max: Tmbs_epd;
		ldif: TLabel;
		dif: Tmbs_epd;
		plh: TCheckBox;
		rdy: TCheckBox;
		inv: TCheckBox;
		lpa0:	TLabel;
		pa0: Tmbs_epi;
		lhst:	TLabel;
		hst: Tmbs_lab;
		lprl: TLabel;
		prl: Tmbs_lab;
		lblk:	TLabel;
		blk: Tmbs_lab;
		pm: TPopupMenu;
		pmf: TMenuItem;
		pmb: TMenuItem;
		N2: TMenuItem;
		pmu: TMenuItem;
		pmz: TMenuItem;
		N1: TMenuItem;
		pma: TMenuItem;
		pmo: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure pmbClick(Sender: TObject);
		procedure pmfClick(Sender: TObject);
		procedure pmuClick(Sender: TObject);
		procedure pmzClick(Sender: TObject);
		procedure pmoClick(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure RecMess(fld: tmbs_fld; mess: boolean);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(f: tmbs_fld);
	end;

var
	fLck:			TfLck;

implementation

uses mbs_bea_u, mbs_uhr_u;

{$R *.DFM}

procedure TfLck.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfLck.GetPar;
var
	v:			Tmbs_vrb;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := true;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;

		pin.adr := mw.w.ad[0];
		iniset(pin.adr.dc, pin.adr.dv, true);

		plh.Checked := mw.dini.ReadInteger(mw.sdev, 'phi', 1) > 0;
		rdy.Checked := mw.dini.ReadInteger(mw.sdev, 'swf', 0) > 0;
		inv.Checked := mw.dini.ReadInteger(mw.sdev, 'inf', 0) > 0;
		dif.Value := mw.dini.ReadInteger(mw.sdev, 'dif', 10);
		min.Value := mw.dini.ReadInteger(mw.sdev, 'krz', 1);
		max.Value := mw.dini.ReadInteger(mw.sdev, 'lng', 127);

		par.Caption := sftab[integer(mw.w.ftyp)];
		prl.pos := point(0, 0);
		blk.pos := point(0, 0);
		hst.pos := point(0, 0);
		mw.w.FstVerb;
		while mw.w.GetVerb(v)
		do begin
			if v.fix = prl.tag
			then begin
				if ftlck = mw.ftab[v.x, v.y].FTyp
				then begin
					prl.Pos := point(v.x, v.y);
				end
				else mw.w.DelVerb(v);
				continue;
			end;
			if v.fix = blk.tag
			then begin
				if ftaus = mw.ftab[v.x, v.y].FTyp
				then begin
					blk.Pos := point(v.x, v.y);
				end
				else mw.w.DelVerb(v);
				continue;
			end;
			if v.fix = hst.tag
			then begin
				if ftStp = mw.ftab[v.x, v.y].FTyp
				then begin
					hst.Pos := point(v.x, v.y);
				end
				else mw.w.DelVerb(v);
				continue;
			end;
		end;
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
	end;
end;

// alle parameter aus formular
procedure TfLck.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[0] := pin.Adr;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);
// schranke					dev 	par	blk	hst	ktimer
//	0 = offen								=0		=1
// 1 = blinken						=1		=1		=0		par0->+
// 2 = schlieen			=0
//		stat+ von decoder oder 4 vonktimer
// 3 = zu
// 4 = ffnen				=1		=4
//		stat+ von decoder oder 4 von decoder
// 6
// 7
		mw.w.SetIpar(par0, pa0.value);
		if plh.Checked
		then mw.dini.WriteInteger(mw.sdev, 'phi', 4)
		else mw.dini.WriteInteger(mw.sdev, 'phi', 0);
		if rdy.Checked
		then mw.dini.WriteInteger(mw.sdev, 'swf', 2)
		else mw.dini.WriteInteger(mw.sdev, 'swf', 0);
		if inv.Checked
		then mw.dini.WriteInteger(mw.sdev, 'inv', 1)
		else mw.dini.WriteInteger(mw.sdev, 'inv', 0);
		mw.dini.WriteInteger(mw.sdev, 'dif', dif.Value);
		mw.dini.WriteInteger(mw.sdev, 'krz', min.Value);
		mw.dini.WriteInteger(mw.sdev, 'lng', max.Value);

		mw.w.SetIpar(par0, 0);
		av_timnxt(mw.w, sta1, 6);         	// nach 3sek stat+
		if pin.Adr.dc = 0
		then begin
			mw.w.SetIpar(par0, 8);
			av_timparnxt(mw.w, sta2, par0);
			av_timparnxt(mw.w, sta4, par0);
		end;
		// parallele Schranke
		if prl.X > 0
		then begin
			if ftlck = mw.ftab[prl.X, prl.Y].FTyp
			then begin
				av_fixsta(prl, sta7, prl.tag, sst6);
				av_fixsta(prl, belp, 1, sblp);		// bel+ weiter
				av_fixsta(prl, belm, 1, sblm);		// bel- weiter
				mw.ftab[prl.x, prl.y].SetIpar(par0, pa0.value);
				// par hat kein device
				if mw.ftab[prl.x, prl.y].Ad[0].dc = 0
				then begin
					mw.ftab[prl.x, prl.y].SetIpar(par0, 0);
					av_fixsta(prl, sta0, 1, sst0);
					av_fixsta(prl, sta3, 1, sst3);
				end;
			end
			else prl.Clear;
		end;
		// haltestelle
		if hst.X > 0
		then begin
			if ftStp = mw.ftab[hst.X, hst.Y].FTyp
			then begin
				av_fixsta(hst, sta0, hst.tag, sst1);
				av_fixsta(hst, sta1, 1, sst0);
				av_fixsta(hst, sta7, 1, sst1);
			end
			else hst.Clear;
		end;
		// blinklicht
		if blk.X > 0
		then begin
			if ftaus = mw.ftab[blk.X, blk.Y].FTyp
			then begin
				av_fixsta(blk, sta0, blk.tag, sst1);
				av_fixsta(blk, sta1, 1, sst0);
				av_fixsta(blk, sta7, 1, sst0);
			end
			else blk.Clear;
		end;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfLck.draw(f: tmbs_fld);
var
	c:		byte;
begin
	with mw.bm.Canvas
	do begin
		c := f.Conn shl 2 + f.Conn shr 6;
		case f.Stat of
		sta0:	pen.Color := cllime;
		sta1:	pen.Color := clgreen;
		sta2:	pen.Color := clyellow;
		sta3:	pen.Color := clred;
		sta4:	pen.Color := clyellow;
		else
			pen.color := clmaroon;
		end;
		f.DrawConn(c, 5, 4);
	end;
end;

// empangene meldungen
procedure TfLck.RecMess(fld: tmbs_fld; mess: boolean);
begin
	if (fld.Stat = sta2)
	and not mess
	then fld.Stat := sta3;
	if (fld.Stat = sta4)
	and mess
	then fld.Stat := sta0;
end;

// statusnderung
procedure TfLck.SetStat(fld: tmbs_fld; stat: tsta);
var
	zsta:		tsta;
begin
	case stat of
	sta7: mbs_uhr_f.delktimer(fld);
	belp:	inc(fld.Z.Blgt);
	belm: if fld.blgt > 0
		then dec(fld.Z.Blgt)
		else exit;
	end;
	zsta := fld.stat;
	fld.setstatcom(stat);
	case fld.stat of
	sta7:
		begin
			fld.Z.Blgt := 0;
			fld.stat := sta0;
		end;
	belp: begin
			if fld.blgt = 1
			then fld.Stat := sta1
			else fld.Stat := zsta;
		end;
	belm: begin
			if fld.blgt = 0
			then fld.Stat := sta4
			else fld.Stat := zsta;
		end;
	end;
	fld.Paint(0);
end;

// statusnderung durch Click
procedure TfLck.ChngStat;
var
	p:			TPoint;
begin
	pmf.Enabled := mw.run;
	pmb.Enabled := mw.run;
	pmz.Visible := mw.test;
	pmu.Visible := mw.test;
	pmo.Visible := mw.test;
	p.x := mw.w.X * gr;
	p.y := mw.w.Y * gr;
	if mw.w.X < mw.trenn
	then p := mw.i1.ClientToScreen(p)
	else p := mw.i2.ClientToScreen(p);
	pm.Popup(p.x, p.y);
end;

// statustabelle versorgen
procedure TfLck.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptsrv;
	fld.Stan := 5;
end;

procedure TfLck.pmbClick(Sender: TObject);
begin
	mw.w.Stat := belp;				// belegen -> schlieen
end;

procedure TfLck.pmfClick(Sender: TObject);
begin
	mw.w.Stat := belm;			// freigeben -> ffnen
end;

procedure TfLck.pmuClick(Sender: TObject);
begin
	recmess(mw.w, false);  	// zu
end;

procedure TfLck.pmoClick(Sender: TObject);
begin
	recmess(mw.w, true);  	// offen
end;

procedure TfLck.pmzClick(Sender: TObject);
begin
	mw.w.Stat := sta7;			// reset
end;

end.
