unit mbs_lok_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, ComCtrls, StdCtrls, ExtCtrls,
	mbs_prt, math, inifiles, Menus;

type
	TStat =
		(stibhf        // im Bahnhof
		,stzstr			// zur Strecke
		,stastr        // auf der Strecke
		,stzbhf			// zum Bahnhof
		);

	Tmbs_lok_f =
	class(TForm)
		p1: TPanel;
		bl: TPanel;
		b1: TPanel;
		b2: TPanel;
		b3: TPanel;
		b4: TPanel;
		b5: TPanel;
		b6: TPanel;
		b7: TPanel;
		b8: TPanel;
		bd: TPanel;
		be: TPanel;
		ln: TLabel;
		li: TLabel;
		ls: TLabel;
		lz: TLabel;
		lx: TLabel;
    	sp: TTrackBar;
		procedure FormActivate(Sender: TObject);
		procedure bdClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure fg1Click(Sender: TObject);
		procedure fg2Click(Sender: TObject);
		procedure spChange(Sender: TObject);
    	procedure beClick(Sender: TObject);
		procedure bMouseDown(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
		procedure bMouseUp(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
		procedure FormKeyDown(Sender: TObject;
			var Key: Word;
			Shift: TShiftState);
		procedure FormDeactivate(Sender: TObject);
    	procedure lzClick(Sender: TObject);
	private		{ Private-Deklarationen }
		FPort: Tmbs_prt;   					// Ausgabeport
		FAdr: word;								// lokadresse
		FInd: byte;
		FStufen: byte;                   // Stufen
		FISteps: byte;                   // Stufen
		FIni: Tinifile;

		FZiel: dword;
		Stat: TStat;
		Strecke: boolean;
		FGruppe: array [1..2] of byte;	// Funktionstasten
		FOnChange: tnotifyevent;
		FPop: Tpopupmenu;

		procedure SetAdr(Value: word);
		procedure SetInd(Value: byte);
		function GetFtst(SetInd: byte): boolean;
		procedure SetFtst(SetInd: byte;
					value: boolean);
		function GetBez: string;
		procedure SetBez(Value: string);
		function GetSpeed: byte;
		procedure SetSpeed(Value: byte);
		function GetDir: boolean;
		procedure SetDir(Value: boolean);
		function GetStufen: byte;
		procedure SetStufen(Value: byte);
	public	   { Public-Deklarationen }
		procedure Ziel(txt: string);
		procedure Zielerr();
		function Wo: byte;
		procedure Anlage(anlage: string);

		property Port:	tmbs_prt
					read FPort
					write FPort;
		property Adr: word
					read FAdr
					write SetAdr;
		property Ini: TInifile
					read FIni
					write FIni;
		property Index: byte
					read FInd
					write SetInd;
		property FTaste[SetInd: byte]:	boolean
					read GetFtst
					write SetFtst;
		property Bez: string
					read GetBez
					write Setbez;
		property Speed: byte
					read GetSpeed
					write SetSpeed;
		property Dir: Boolean
					read GetDir
					write SetDir;
		property Stufen: byte
					read GetStufen
					write SetStufen;
		property ISteps: byte
					read FISteps
					write FISteps;
		property pop: tpopupmenu
					write Fpop;
		property OnChange: TNotifyevent
			read FOnChange
			write FOnchange;
	end;

var
	ftab: array [0..8] of tpanel;
	anl: string;				// Anlagenverzeichnis;

implementation

{$R *.DFM}

procedure Tmbs_lok_f.FormActivate(Sender: TObject);
begin
	width := p1.Width;
	ln.Font.Style := [fsbold];
	ln.Font.Color := clblue;
	be.SetFocus;
end;

procedure Tmbs_lok_f.Anlage(anlage: string);
begin
	anl := anlage;
end;

procedure Tmbs_lok_f.SetAdr(value: word);
var
	i: integer;
begin
	FAdr := value;
	if value = 0
	then begin
		visible := false;
		exit;
	end;
	visible := true;
	if not assigned(fini)
	then exit;
	FStufen := fini.ReadInteger('lok', 'stufen', 28);
//	FAdr := ini.ReadInteger('CV1', 'Wert', 0);
//	ln.caption := ini.ReadString('lok', 'name', '#' + inttostr(FAdr));
	if FAdr > 0
	then begin
		li.Caption := format('%3d-%s%s',
				[FAdr,
				char(fini.ReadInteger('CV105', 'Wert', 32)),
				char(fini.ReadInteger('CV106', 'Wert', 32))]);
		li.Hint := 'Decoder='
				+ fini.ReadString('lok', 'decoder', '???')
				+ #13 + #10
				+ 'max-Stufen='
				+ inttostr(fini.readinteger('lok', 'maxstufen', 28));
		ln.Hint := li.Hint;
		sp.Tag := 99;
		bd.Tag := 128;
		bd.Caption := 'V';
		for i := 0 to 8
		do begin
			if fini.ReadBool('lok', 'F' + inttostr(i), false)
			then begin
				ftab[i].Tag := ftab[i].Tag or (ftab[i].Tag shr 8);
				ftab[i].BevelOuter := bvLowered;
			end
			else begin
				ftab[i].Tag := ftab[i].Tag and $ff00;
				ftab[i].BevelOuter := bvRaised;
			end;
		end;
		speed := 0;
		fport.SendAdr(FInd, fadr);
		fport.SendSpd(FInd, getspeed());
		fg1click(self);
		fg2click(self);
	end
	else begin
		li.Caption := '';
		li.Hint := anl + ln.caption + '.lok';
		li.color := clred;
	end;
end;

procedure Tmbs_lok_f.SetInd(value: byte);
begin
	FInd := value;
	lx.Caption := inttostr(FInd);
	exit;
	// alle Daten schicken
	fport.SendAdr(FInd, fadr);
	fport.SendSpd(FInd, getspeed());
	fg1click(self);
	fg2click(self);
//	fg3click;
end;

function Tmbs_lok_f.GetFtst(SetInd: byte): boolean;
begin
	result := (ftab[SetInd].Tag and $00ff) > 0;
end;

procedure Tmbs_lok_f.SetFtst(SetInd: byte; value: boolean);
begin
	if value
	then begin
		ftab[SetInd].tag := ftab[SetInd].Tag
							+ ftab[SetInd].Tag shr 8;
		ftab[SetInd].Font.Style := [fsbold];
	end
	else begin
		ftab[SetInd].tag := ftab[SetInd].Tag and $ff00;
		ftab[SetInd].Font.Style := [];
	end;
	if SetInd > 4
	then fg2click(ftab[5])
	else fg1click(ftab[0]);
end;

function Tmbs_lok_f.GetBez: string;
begin
	result := ln.caption;
end;

procedure Tmbs_lok_f.SetBez(Value: string);
var
	i: integer;
begin
	ln.Caption := Value;
	if value = ''
	then begin
		visible := false;
		exit;
	end;
	visible := true;
	if not assigned(fini)
	then exit;
	FStufen := fini.ReadInteger('lok', 'stufen', 28);
	FAdr := fini.ReadInteger('CV1', 'Wert', 0);
	if FAdr > 0
	then begin
		li.Caption := format('%3d-%s%s',
				[FAdr,
				char(ini.ReadInteger('CV105', 'Wert', 32)),
				char(ini.ReadInteger('CV106', 'Wert', 32))]);
		li.Hint := 'Decoder='
				+ ini.ReadString('lok', 'decoder', '???')
				+ #13 + #10
				+ 'max-Stufen='
				+ inttostr(ini.readinteger('lok', 'maxstufen', 28));
		ln.Hint := li.Hint;
		sp.Tag := 99;
		bd.Tag := 128;
		bd.Caption := 'V';
		for i := 0 to 8
		do begin
			if ini.ReadBool('lok', 'F' + inttostr(i), false)
			then begin
				ftab[i].Tag := ftab[i].Tag or (ftab[i].Tag shr 8);
				ftab[i].BevelOuter := bvLowered;
			end
			else begin
				ftab[i].Tag := ftab[i].Tag and $ff00;
				ftab[i].BevelOuter := bvRaised;
			end;
		end;
		speed := 0;
//		fg1click(self);
//		fg2click(self);
	end
	else begin
		li.Caption := '';
		li.Hint := anl + ln.caption + '.lok';
		li.color := clred;
	end;
	ini.Free;
end;

function Tmbs_lok_f.GetSpeed: byte;
begin
	result := abs(sp.Position);
end;

procedure Tmbs_lok_f.SetSpeed(Value: byte);
begin
	sp.Position := value * -1;
end;

function Tmbs_lok_f.GetDir: boolean;
begin
	result := bd.Tag = 128;
end;

procedure Tmbs_lok_f.SetDir(Value: boolean);
begin
	if (bd.Tag = 128) <> value
	then bdclick(self);
end;

procedure Tmbs_lok_f.bdClick(Sender: TObject);
begin
	if bd.Tag > 0
	then begin
		bd.Tag := 0;
		bd.Caption := 'R';
	end
	else begin
		bd.Tag := 128;
		bd.Caption := 'V';
	end;
	spchange(self);
end;

procedure Tmbs_lok_f.FormCreate(Sender: TObject);
begin
	ftab[0] := bl;			// licht
	bl.Tag := $1000;
	ftab[1] := b1;			// f1
	b1.Tag := $0100;
	ftab[2] := b2;			// f2
	b2.Tag := $0200;
	ftab[3] := b3;			// f3
	b3.Tag := $0400;
	ftab[4] := b4;			// f4
	b4.Tag := $0800;
	ftab[5] := b5;			// f5
	b5.Tag := $0100;
	ftab[6] := b6;			// f6
	b6.Tag := $0200;
	ftab[7] := b7;			// f7
	b7.Tag := $0400;
	ftab[8] := b8;			// f8
	b8.Tag := $0800;
	FStufen := 28;
end;

procedure Tmbs_lok_f.fg1Click(Sender: TObject);
begin
	if sender is tpanel
	then begin
		with sender as tPanel
		do begin
			if (tag and $00ff) = 0
			then begin
				tag := tag or tag shr 8;
				BevelOuter := bvLowered;
			end
			else begin
				tag := tag and $ff00;
				BevelOuter := bvRaised;
			end;
		end;
	end;
	FGruppe[1] := ftab[0].Tag
				or ftab[1].Tag
				or ftab[2].Tag
				or ftab[3].Tag
				or ftab[4].Tag;
	FPort.SendFG1(FInd, FGruppe[1]);
//	if p1.visible
//	then bd.SetFocus;
end;

procedure Tmbs_lok_f.fg2Click(Sender: TObject);
begin
	if sender is tpanel
	then begin
		with sender as tPanel
		do begin
			if (tag and $00ff) = 0
			then begin
				tag := tag or tag shr 8;
				BevelOuter := bvLowered;
			end
			else begin
				tag := tag and $ff00;
				BevelOuter := bvRaised;
			end;
		end;
	end;
	FGruppe[2] := ftab[5].Tag
				or ftab[6].Tag
				or ftab[7].Tag
				or ftab[8].Tag;
	FPort.SendFG2(FInd, FGruppe[2]);
//	if visible
//	then bd.SetFocus;
end;

procedure Tmbs_lok_f.spChange(Sender: TObject);
begin
	if sp.Position + bd.Tag = sp.tag
	then exit;
	if sp.Position = 0
	then FPort.Speed28(
						FInd,
						0,
						(bd.Tag > 0))
	else FPort.Speed28(
						FInd,
						abs(sp.Position) + 3,
						(bd.Tag > 0));
	ls.Caption := inttostr(abs(sp.position))
					+ '/'
					+ inttostr(FStufen);
	sp.tag := sp.Position + bd.tag;
end;

function Tmbs_lok_f.GetStufen(): byte;
begin
	result := FStufen;
end;

procedure Tmbs_lok_f.SetStufen(Value: byte);
begin
	case value of
	14, 28, 126:	FStufen := value;
	else FStufen := 28;
	end;
end;

function Tmbs_lok_f.wo: byte;
begin
	result := fziel;
end;

procedure Tmbs_lok_f.beClick(Sender: TObject);
begin
	FPort.EmStop(FInd, bd.tag > 0);
end;

procedure Tmbs_lok_f.bMouseDown(Sender: TObject;
	Button: TMouseButton;
	Shift: TShiftState;
	X, Y: Integer);
begin
	with sender as tpanel
	do bevelouter := bvLowered;
end;

procedure Tmbs_lok_f.bMouseUp(Sender: TObject;
	Button: TMouseButton;
	Shift: TShiftState;
	X, Y: Integer);
begin
	with sender as tpanel
	do bevelouter := bvRaised;
end;

procedure Tmbs_lok_f.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	case key of
	VK_SPACE:		//	Taste Leer
		beclick(be);
	VK_PRIOR:		// Taste Bild auf
		speed := speed + 7;
	VK_NEXT:			//	Taste Bild ab
		speed := speed - 7;
	VK_LEFT:			//	Taste Links
		if bd.Tag > 0
		then bdclick(bd);
	VK_UP:			//	Taste Auf
		speed := speed + 1;
	VK_RIGHT:		//	Taste Rechts
		if bd.Tag = 0
		then bdclick(bd);
	VK_DOWN:			//	Taste Ab
		speed := speed - 1;
	VK_F1:			//	Taste F1
		fg1click(b1);
	VK_F2:			//	Taste F2
		fg1click(b2);
	VK_F3:			//	Taste F3
		fg1click(b3);
	VK_F4:			//	Taste F4
		fg1click(b4);
	VK_F5:			//	Taste F5
		fg2click(b5);
	VK_F6:			//	Taste F6
		fg2click(b6);
	VK_F7:			//	Taste F7
		fg2click(b7);
	VK_F8:			//	Taste F8
		fg2click(b8);
	VK_F10:			//	Taste F10
		fg1click(bl);
	end;
	key := 0;
end;

procedure Tmbs_lok_f.FormDeactivate(Sender: TObject);
begin
	ln.Font.Style := [];
	ln.Font.Color := clblack;
end;

procedure Tmbs_lok_f.lzClick(Sender: TObject);
var
	i: integer;
begin
	if not Assigned(fpop)
	then exit;
	fpop.PopupComponent := self;
	for i := 0 to fpop.Items.Count - 1
	do begin
		if fpop.Items[i].Caption = '-'
      then break;
		if i = 0
		then fpop.Items[i].Enabled := stat = stibhf		// Strecke
		else fpop.Items[i].Enabled := stat = stastr;
	end;
	fpop.Popup(sp.ClientOrigin.x, sp.ClientOrigin.y);
end;

procedure Tmbs_lok_f.Zielerr;
begin
	if pos('->', lz.Caption) > 0
	then lz.Caption := copy(lz.Caption, 3, 50);
	if Stat = stzbhf		// Bahnhof erreicht
	then begin
		p1.Color := clgray;
		sp.Tag := 255;
		speed := 0;
		spchange(self);
		fg1click(self);
		fg2click(self);
		sp.SliderVisible := false;
		sp.SliderVisible := true;
		Stat := stibhf;
	end;
	if Stat = stzstr		// Strecke erreicht
	then begin
		stat := stastr;
	end;
end;

procedure Tmbs_lok_f.Ziel(txt: string);
begin
	if pos('->', lz.Caption) > 0
	then exit;
	lz.Caption := txt;
	p1.Color := clBtnFace;
	sp.SliderVisible := false;
	sp.SliderVisible := true;
	if stat = stibhf
	then Stat := stzstr;
	if stat = stastr
	then Stat := stzbhf;
end;

end.
