unit mbs_mon_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, menus, ExtCtrls,
	mbs_fld, mbs_prt;

const
	cpsysc: array [1..4] of dword =
		($f0ffffff, $fff0ffff, $fffff0ff, $fffffff0);
	cpdecc: array [1..4] of dword =
		($0fffffff, $ff0fffff, $ffff0fff, $ffffff0f);
	stxt: array [0..3] of string =
	('off', 'on', 'rdy off', 'rdy on');
	dtxt: array [0..3] of string =
	('off', 'on', 'ready', 'ready');
	atxt: array [0..15] of string =
	('...x00', 'reset ', 'start ', '...x03',
	 '...x04', '...x05', '...x06', '...x07',
	 's dec#', '...x09', '...x0a', '...x0b',
	 '...x0c', '...x0d', '...x0e', 'l test'
	 );
	iprt: array [0..7] of char =
	('-', 'A', 'B', 'C', 'D', 'E', 'F', 'P');
	oprt: array [0..6] of char =
	('-', 'a', 'b', 'c', 'd', 'e', 'f');

type
	Tmbs_mon_f =
	class(TForm)
		mon: TListBox;
		lb: TListBox;
		mm: TMainMenu;
		K1: TMenuItem;
		L1: TMenuItem;
		V1: TMenuItem;
		anz: TLabel;
		W1: TMenuItem;
		call1: TMenuItem;
		Timer1: TMenuItem;
		N1: TMenuItem;
		nix1: TMenuItem;
		kadr: TMenuItem;
		systim: TTimer;
		mmdec: TMenuItem;
		mmalle: TMenuItem;
		N2: TMenuItem;
		Nummer1: TMenuItem;
		procedure monDblClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormClose(Sender: TObject;
			var Action: TCloseAction);
		procedure FormActivate(Sender: TObject);
		procedure V1Click(Sender: TObject);
		procedure nix1Click(Sender: TObject);
		procedure L1Click(Sender: TObject);
		procedure K1Click(Sender: TObject);
		procedure W1Click(Sender: TObject);
		procedure call1Click(Sender: TObject);
		procedure kadrClick(Sender: TObject);
		procedure systimTimer(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure mmalleClick(Sender: TObject);
		procedure Nummer1Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public      { Public-Deklarationen }
		procedure Add(
			Sender: TObject;
			str: string);
	end;

var
	mbs_mon_f: 	Tmbs_mon_f;
	mw:			ptmbswork;
	hex,
	nsn:			boolean;

implementation

uses ape_u, mbs_uhr_u, mbs_u;

{$R *.DFM}

procedure Tmbs_mon_f.FormCreate(Sender: TObject);
begin
	mw := ptmbswork(application.Tag);
	inherited;
end;

procedure Tmbs_mon_f.FormActivate(Sender: TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end;
end;

procedure Tmbs_mon_f.FormClose(Sender: TObject;
				var Action: TCloseAction);
begin
	mw.mmon.click;
	action := canone;
end;

procedure Tmbs_mon_f.FormDestroy(Sender: TObject);
begin
	systim.Free;
end;

procedure Tmbs_mon_f.Add(
	Sender: TObject;
	str: string);
begin
	if mon.Height div mon.ItemHeight <= mon.Items.Count
	then mon.Items.Delete(0);
	if length(mmdec.caption) > 3
	then begin
		mon.items.add(str);
	end
	else begin
		if (copy(str, 7, 3) = '  0')
		or (copy(str, 7, 3) = mmdec.Caption)
		then begin
			mon.items.add(str);
		end
	end;
end;

procedure Tmbs_mon_f.monDblClick(Sender: TObject);
begin
	mon.clear;
end;

procedure Tmbs_mon_f.nix1Click(Sender: TObject);
begin
	nix1.checked := true;
	anz.Visible := false;
	lb.Visible := false;
	lb.clear;
end;

procedure Tmbs_mon_f.V1Click(Sender: TObject);
begin
	nix1click(self);
	v1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Verbindungen';
end;

procedure Tmbs_mon_f.L1Click(Sender: TObject);
begin
	nix1click(self);
	l1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Langzeittimer';
end;

procedure Tmbs_mon_f.K1Click(Sender: TObject);
begin
	nix1click(self);
	k1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Kurzzeittimer';
end;

procedure Tmbs_mon_f.W1Click(Sender: TObject);
begin
	nix1click(self);
	w1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Kurzzeittimer warten';
end;

procedure Tmbs_mon_f.call1Click(Sender: TObject);
begin
	call1.Checked := call1.Checked xor true;
	hex := call1.Checked;
end;

procedure Tmbs_mon_f.kadrClick(Sender: TObject);
begin
	kadr.Checked := kadr.Checked xor true;
	nsn := kadr.Checked;
end;

procedure Tmbs_mon_f.systimTimer(Sender: TObject);
var
	i:			integer;
begin
	systim.Enabled := false;
	with mbs_f
	do begin
		for i := 1 to 4
		do begin
			if scres[i]
			then begin
				showmessage('Port '
					+ iprt[i]
					+ ' Reset Message nicht empfangen');
				scres[i] := false;
			end;
			if scsta[i]
			then begin
				showmessage('Port '
					+ iprt[i]
					+ ' Start Message nicht empfangen');
				scsta[i] := false;
			end;
			if scdec[i]
			then begin
				showmessage('Port '
					+ iprt[i]
					+ ' Decoder meldet sich nicht');
				scdec[i] := false;
			end;
			if sctst[i]
			then begin
				showmessage('Port '
					+ iprt[i]
					+ ' Schleife offen');
				sctst[i] := false;
			end;
		end;
	end;
end;

procedure Tmbs_mon_f.mmalleClick(Sender: TObject);
begin
	mmdec.Tag := 0;
	mmdec.Caption := 'Decoder';
end;

procedure Tmbs_mon_f.Nummer1Click(Sender: TObject);
var
	s: string;
begin
	if inputquery('Decoder auwhlen', 'Decoder#', s)
	then begin
		s := '   ' + trim(s);
		mmdec.Caption := copy(s, length(s) - 2, 3);
	end;
end;

end.
