unit mbs_mon_u_alt;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, menus, ExtCtrls,
	mbs_fld, cport;

const
	cpbaud = brcustom;
//	cubaud = 20833;
	cubaud = 19200;
	cpdata = dbeight;
	cppari = prnone;
	cppchk = false;
	cpsysc: array [1..4] of dword =
		($f0ffffff, $fff0ffff, $fffff0ff, $fffffff0);
	cpdecc: array [1..4] of dword =
		($0fffffff, $ff0fffff, $ffff0fff, $ffffff0f);
	stxt: array [0..3] of string =
	('off', 'on', 'rdy off', 'rdy on');
	dtxt: array [0..3] of string =
	('off', 'on', 'ready', 'ready');
	atxt: array [0..15] of string =
	('...x00', 'reset ', 'start ', '...x03',
	 '...x04', '...x05', '...x06', '...x07',
	 's dec#', '...x09', '...x0a', '...x0b',
	 '...x0c', '...x0d', '...x0e', 'l test'
	 );
	iprt: array [0..4] of char =
	('-', 'A', 'B', 'C', 'D');
	oprt: array [0..4] of char =
	('-', 'a', 'b', 'c', 'd');

type
	Tms =
	record
		dc:		word;
		dv,
		pa,
		dt:		byte;
		rx,
		nu,
		ft:		boolean;
	end;
	pTms = ^Tms;

	Tmbs_mon_f =
	class(TForm)
		mon: TListBox;
		lb: TListBox;
		mm: TMainMenu;
		K1: TMenuItem;
		L1: TMenuItem;
		V1: TMenuItem;
		anz: TLabel;
		W1: TMenuItem;
		call1: TMenuItem;
		Timer1: TMenuItem;
		N1: TMenuItem;
		nix1: TMenuItem;
		kadr: TMenuItem;
		systim: TTimer;
		procedure monDblClick(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormClose(Sender: TObject;
						var Action: TCloseAction);
		procedure FormActivate(Sender: TObject);
		procedure V1Click(Sender: TObject);
		procedure nix1Click(Sender: TObject);
		procedure L1Click(Sender: TObject);
		procedure K1Click(Sender: TObject);
		procedure W1Click(Sender: TObject);
		procedure call1Click(Sender: TObject);
		procedure kadrClick(Sender: TObject);
		procedure systimTimer(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
	private		{ Private-Deklarationen }
	public      { Public-Deklarationen }
		procedure Add(str: string);
		function	Open(
						ind: byte;
						cap: string): boolean;
		function	Close(
						ind: byte): boolean;
		function	SendCom(
						prt: byte;
						dec: word;
						dev, sta: byte): boolean;
		function	SendPar(
						prt: byte;
						dec: word;
						dev, par, wrt: byte): boolean;
		procedure cpError(Sender: TObject; Errors: TComErrors);
		procedure cpRxChar(Sender: TObject; Count: Integer);
	end;

var
	mbs_mon_f: 	Tmbs_mon_f;
	mw:			ptmbswork;
	hex,
	nsn:			boolean;
	ms:			array [1..4] of Tms;
	cp:			array [1..4] of tcomport;
	rxr:			array [1..4] of boolean;

implementation

uses ape_u, mbs_uhr_u;

{$R *.DFM}

procedure Tmbs_mon_f.FormCreate(Sender: TObject);
var
	i:			integer;
begin
	for i := 1 to 4
	do begin
		cp[i] := tcomport.Create(self);
		cp[i].OnError := cperror;
		cp[i].OnRxChar := cprxchar;
		cp[i].BaudRate := cpbaud;
		cp[i].CustomBaudRate := cubaud;
		cp[i].DataBits := cpdata;
		cp[i].Parity.Bits := cppari;
		cp[i].Parity.Check := cppchk;
		cp[i].StopBits := sbOneStopBit;
		cp[i].Tag := i;
		cp[i].Events := [evrxchar, everror];
		cp[i].SyncMethod := smThreadSync;
		cp[i].Timeouts.ReadTotalConstant := 10;
		cp[i].Timeouts.ReadTotalMultiplier := 1;
		ms[i].rx := false;
	end;
	mw := ptmbswork(application.Tag);
end;

procedure Tmbs_mon_f.FormActivate(Sender: TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end;
end;

procedure Tmbs_mon_f.FormClose(Sender: TObject;
				var Action: TCloseAction);
begin
	mw.mmon.click;
	action := canone;
end;

procedure Tmbs_mon_f.FormDestroy(Sender: TObject);
var
	i:			integer;
begin
	systim.Free;
	for i := 1 to 4
	do begin
		if cp[i].Connected
		then begin
			cp[i].AbortAllAsync;
			cp[i].Close;
		end;
		cp[i].Free;
	end;
end;

procedure Tmbs_mon_f.Add(str: string);
begin
	if mon.Height div mon.ItemHeight <= mon.Items.Count
	then mon.Items.Delete(0);
	mon.items.add(str);
end;

procedure Tmbs_mon_f.monDblClick(Sender: TObject);
begin
	mon.clear;
end;

procedure Tmbs_mon_f.nix1Click(Sender: TObject);
begin
	nix1.checked := true;
	anz.Visible := false;
	lb.Visible := false;
	lb.clear;
end;

procedure Tmbs_mon_f.V1Click(Sender: TObject);
begin
	nix1click(self);
	v1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Verbindungen';
end;

procedure Tmbs_mon_f.L1Click(Sender: TObject);
begin
	nix1click(self);
	l1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Langzeittimer';
end;

procedure Tmbs_mon_f.K1Click(Sender: TObject);
begin
	nix1click(self);
	k1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Kurzzeittimer';
end;

procedure Tmbs_mon_f.W1Click(Sender: TObject);
begin
	nix1click(self);
	w1.Checked := true;
	anz.Visible := true;
	lb.Visible := true;
	anz.caption := 'Kurzzeittimer warten';
end;

procedure Tmbs_mon_f.call1Click(Sender: TObject);
begin
	call1.Checked := call1.Checked xor true;
	hex := call1.Checked;
end;

procedure Tmbs_mon_f.kadrClick(Sender: TObject);
begin
	kadr.Checked := kadr.Checked xor true;
	nsn := kadr.Checked;
end;

procedure Tmbs_mon_f.systimTimer(Sender: TObject);
var
	i:			integer;
begin
	systim.Enabled := false;
	for i := 3 downto 0
	do begin
		case systim.Tag and $0000000f of
		0:		;
		1: 	showmessage(format('Port %s: Reset Message nicht empfangen', [char(i + 65)]));
		2: 	showmessage(format('Port %s: Start Message nicht empfangen', [char(i + 65)]));
		8,		// 	showmessage(format('Port %s: Decoder meldet sich nicht', [char(i + 65)]));
		15:	showmessage(format('Port %s: Schleife offen', [char(i + 65)]));
		else  showmessage(format('Port %s: System Message nicht empfangen', [char(i + 65)]));
		end;
		case systim.Tag and $000000ff of
		136: 	showmessage(format('Port %s: Decoder meldet sich nicht', [char(i + 65)]));
		end;
		systim.tag := systim.Tag shr 8;
	end;
end;

procedure Tmbs_mon_f.cpError(Sender: TObject; Errors: TComErrors);
begin
	case byte(errors) of
	byte(ceFrame):		add('***** Frame Error');
	byte(ceRxParity): add('***** Rx Parity Error');
	byte(ceOverrun):  add('***** Overrun');
	byte(ceBreak):    add('***** Break');
	byte(ceIO):       add('***** IO Error');
	byte(ceMode):     add('***** Mode Error');
	byte(ceRxOver):   add('***** Rx Over');
	byte(ceTxFull):   add('***** Tx Full');
	end;
end;

function	Tmbs_mon_f.SendCom(
				prt: byte;
				dec: word;
				dev, sta: byte): boolean;
const
	frm2 = '%s%s %3d:%2.2d=%2.2x';
var
	s,
	v:			string;
begin
	result := true;
	if mw.mode > 1
	then exit;
	result := false;
	if (prt > 0)
	then begin
		if assigned(cp[prt])
		then begin
			if cp[prt].Connected
			then begin
				s := char(dec or $80)
					+ char(dev + sta * 16);
				cp[prt].writestr(s);
				v := '  ';
				result := true;
			end
			else begin
				v := 'no';
			end;
		end
		else begin
			v := 'nu';
		end;
	end
	else begin
		if dec = 0
		then v := 'na'
		else v := 'np';
	end;
	if (nsn and (v <> '  '))
	or (v = '  ')
	then begin
		s := format(frm2, [v, oprt[prt], dec, dev, sta]);
		Add(s);
	end;
end;

function	Tmbs_mon_f.SendPar(
				prt: byte;
				dec: word;
				dev, par, wrt: byte): boolean;
const
	frm3 = '%s%s %3d:%2.2d.%d=%2.2x';
var
	s,
	v:			string;
begin
	result := true;
	if mw.mode > 1
	then exit;
	result := false;
	if (prt > 0)
	then begin
		if assigned(cp[prt])
		then begin
			if cp[prt].Connected
			then begin
				s := char(dec or $80)
					+ char(dev + par * 16 + $40)
					+ char(wrt);
				cp[prt].writestr(s);
				v := '  ';
				result := true;
			end
			else begin
				v := 'no';
			end;
		end
		else begin
			v := 'nu';
		end;
	end
	else begin
		if dec = 0
		then v := 'na'
		else v := 'np';
	end;
	if (nsn and (v <> '  '))
	or (v = '  ')
	then begin
		s := format(frm3, [v, oprt[prt], dec, dev, par, wrt]);
		Add(s);
	end;
end;

function	Tmbs_mon_f.Open(
				ind: byte;
				cap: string): boolean;
begin
	if cp[ind].Connected
	then cp[ind].Close;
	cp[ind].Port := cap;
	cp[ind].Open;
	ms[ind].rx := false;
	cp[ind].AbortAllAsync;
	result := cp[ind].Connected;
	if result
	then add(cap + ' open')
	else add(cap + 'close');
end;

function	Tmbs_mon_f.Close(
				ind: byte): boolean;
var
	cap: string;
begin
	cap := cp[ind].port;
	cp[ind].Close;
	result := not cp[ind].Connected;
	if not result
	then add(cap + ' open')
	else add(cap + 'close');
end;

procedure Tmbs_mon_f.cpRxChar(Sender: TObject;
				Count: Integer);
var
	str:		string;
	m:			ptms;
	f:			tmbs_fld;
begin
	with sender as tcomport
	do begin
		m := addr(ms[tag]);
		if m.rx
		then begin
			add(format('---%3.3d %d', [count, byte(m.rx)]));
			exit;
		end
		else m.rx := true;
		if hex
		then add(format('..#%3.3d', [count]));
		while Readstr(str, 1) > 0
		do begin
			case byte(str[1]) of
			0..$3f:
				begin
					if m.nu
               then begin
						m.dt := byte(str[1]);
						m.ft := true;
               end
					else begin
						m.dv := byte(str[1]) and $0f;
						m.dt := byte(str[1]) shr 4;
						m.ft := true;
					end;
				end;
			$40..$7f:
				begin
					if m.nu
               then begin
						m.dt := byte(str[1]);
						m.ft := true;
               end
               else begin
						m.dv := byte(str[1]) and $0f;
						m.pa := (byte(str[1]) shr 4) - 4;
						m.nu := true;
					end;
				end;
			128..255:
				begin
					m.dc := byte(str[1]) and $7f;
					m.nu := false;
					m.ft := false;
				end;
			end;
			if m.ft
			and hex
			then begin
				if m.nu
            then begin
					// 3 byte hex
					m.nu := false;
					m.ft := false;
					add(format('>.3 %2.2x %2.2x %2.2x',
							[m.dc + $80, m.dv + m.pa * 16 + $40, m.dt]));
					continue;
				end
            else begin
					add(format('>.2 %2.2x %2.2x',
							[m.dc + $80, m.dv + (m.dt shl 4)]));
				end;
			end;
			// verarb
			if m.ft 								// mess fertig
			then begin
				m.ft := false;
				if not m.nu
				then begin
					if m.dc > 0 					// decoder
					then begin
						if m.dv < 14 				// device meldet
						then begin
							if mw.dtab[m.dc].a	// aktiv
							then begin
								if (mw.dtab[m.dc].f[m.dv] <> nil)
								and mw.run
								then begin
									f := mw.dtab[m.dc].f[m.dv];
									if f.PTyp = ptinp
									then f.Stat := tsta(m.dt and 1)
									else f.nextstat;
								end;
								add(format('>%s %3d %2d %s',
										[iprt[tag], m.dc,
										 m.dv, stxt[m.dt]]));
							end;
						end
						else begin           	// decoder meldet
							mw.dtab[m.dc].a := true;
							mw.dtab[m.dc].c := tag;
							if mw.dtab[m.dc].s = ''
							then mw.dtab[m.dc].s := inttostr(m.dc);
							add(format('>%s %3d %s',
									[iprt[tag], m.dc,
									 dtxt[m.dt]]));
							systim.Tag := systim.Tag and cpdecc[tag];
						end;
					end
					else begin						// syscmd
						if (systim.Tag and (cpsysc[tag] xor $ffffffff)) =
									$02000000 shr ((tag - 1) * 8)
						then dec(mw.pz);
						if mw.pz = 0
						then begin
							mbs_uhr_f.kti.Enabled := true;
							mw.run := true;
						end;
						systim.Tag := systim.Tag and cpsysc[tag];
						systim.Enabled := (systim.Tag > 0);
						add(format('>%s sys %s',
								[iprt[tag], atxt[m.dv]]));
					end;
				end
				else begin
					m.nu := false;
				end;
			end;
		end;
		m.rx := false;
	end;
end;

end.
