unit mbs_spt_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, ExtCtrls;
const
	maxspeed = 128;
	maxstep = 27;

type
	Tmbs_spt_f =
	class(TForm)
		spt: TImage;
		bret: TButton;
		bok: TButton;
		bcan: TButton;
		bdef: TButton;
		cv29: TCheckBox;
		pos: TLabel;
		procedure sptMouseDown(Sender: TObject;
						Button: TMouseButton;
						Shift: TShiftState;
						X, Y: Integer);
		procedure bretClick(Sender: TObject);
		procedure bokClick(Sender: TObject);
		procedure FormShow(Sender: TObject);
		procedure sptMouseMove(Sender: TObject;
						Shift: TShiftState;
						X, Y: Integer);
		procedure sptMouseUp(Sender: TObject;
						Button: TMouseButton;
						Shift: TShiftState;
						X, Y: Integer);
	private		{ Private-Deklarationen }
		procedure setmark;
		procedure showmark;
	public		{ Public-Deklarationen }
		steps: byte;
		marktab:	array [0..maxstep] of integer;
		speedtab: array [0..maxstep] of word;
		minspeed,
		midspeed,
		maxspeed: word;
	end;

var
	mbs_spt_f: 		Tmbs_spt_f;

implementation

{$R *.DFM}

procedure Tmbs_spt_f.setmark;
var
	i:			integer;
begin
	marktab[0] := speedtab[0];
	for i := 1 to maxstep - 1
	do begin
		if abs(speedtab[i - 1]
				+ speedtab[i + 1]
				- speedtab[i] * 2) > 1
		then marktab[i] := round((speedtab[i] * 255) / steps)
		else marktab[i] := -1;
	end;
	marktab[maxstep] := round((speedtab[maxstep] * 255) / steps);
	if marktab[maxstep] > 255
	then marktab[maxstep] := 255;
end;

procedure Tmbs_spt_f.showmark;
var
	i,
	x,
	y:			integer;
begin
	with spt.Canvas
	do begin
		if maxspeed = 0
		then maxspeed := 255;
		if midspeed = 0
		then midspeed := (maxspeed - minspeed) div 2;
		
		pen.Width := 4;
		pen.Color := clsilver;
		rectangle(rect(2, 2, spt.width - 2, spt.height - 2));
		pen.Width := 1;
		// normalkurve
		pen.Color := clred;
		moveto(4, spt.Height - 4 - minspeed);
		lineto(spt.Width div 2, spt.Height - 4 - midspeed);
		lineto(spt.width - 4, spt.Height - 4 - maxspeed);
		// speedtab
		pen.Color := clblack;
		moveto(4, 260 - marktab[0]);
		for i := 0 to maxstep
		do begin
			if marktab[i] > -1
			then begin
				x := i * 8 + 4;
				y := 260 - marktab[i];
				lineto(x, y);
				brush.Color := clblack;
				framerect(rect(x - 4, y - 4, x + 4, y + 4));
				brush.Color := clwhite;
			end;
		end;
		if marktab[maxstep] = -1
		then lineto(maxstep * 8, 0);
	end;
end;

procedure Tmbs_spt_f.bretClick(Sender: TObject);
begin
	setmark;
	showmark;
end;

procedure Tmbs_spt_f.bokClick(Sender: TObject);
var
	i,
	j:			integer;
	wv,
	wb:		integer;
	wd:		double;
begin
	wv := marktab[0];
	speedtab[0] := wv;
	j := 0;
	for i := 1 to maxstep
	do begin
		if marktab[i] > -1
		then begin
			wb := marktab[i];
			wd := (wb - wv) / (i - j);
			wb := marktab[i];
			for j := j + 1 to i
			do begin
				speedtab[j] := round((wb - (wd * (i - j))) * steps / 255);
			end;
			j := i;
			wv := round(marktab[i]);
		end;
	end;
end;

procedure Tmbs_spt_f.FormShow(Sender: TObject);
begin
	setmark;
	showmark;
end;

var
	xx:		word;

procedure Tmbs_spt_f.sptMouseDown(
			Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
begin
	if (y < 4)
	or (y > 258)
	then exit;
	xx := x div 8;
end;

procedure Tmbs_spt_f.sptMouseMove(
	Sender: TObject;
	Shift: TShiftState;
	X, Y: Integer);
begin
	if (y < 4)
	or (y > 258)
	then pos.Caption := ''
	else pos.Caption := inttostr(x div 8 + 1) + '-'
							+ inttostr(steps + 1 - round(y * steps / 255));
end;

procedure Tmbs_spt_f.sptMouseUp(
	Sender: TObject;
	Button: TMouseButton;
	Shift: TShiftState;
	X, Y: Integer);
begin
	if (y < 4)
	then y := y;
	if (y > 258)
	then y := 258;
	if button = mbright
	then marktab[xx] := -1
	else marktab[xx] := 259 - y;
	showmark;
end;

end.
