unit mbs_stp;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfStp =
	class(TForm)
		par: TGroupBox;
		ldif: TLabel;
		lmax: TLabel;
		pin: Tmbs_led;
		lmin: TLabel;
		plh: TCheckBox;
		rdy: TCheckBox;
		inv: TCheckBox;
		min: Tmbs_epd;
		max: Tmbs_epd;
		dif: Tmbs_epd;
		pm: TPopupMenu;
		pmn: TMenuItem;
		N1: TMenuItem;
		pma: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure pmnClick(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure RecMess(fld: tmbs_fld; mess: boolean);
		procedure ChngStat;
		procedure draw(f: tmbs_fld);
	end;

var
	fStp: 		TfStp;

implementation

uses mbs_bea_u, mbs_mon_u;

{$R *.DFM}

procedure TfStp.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfStp.GetPar;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		mw.w.Stan := 2;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := false;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		
		pin.adr := mw.w.ad[0];
		iniset(pin.adr.dc, pin.adr.dv, true);

		plh.Checked := mw.dini.ReadInteger(mw.sdev, 'phi', 1) > 0;
		rdy.Checked := mw.dini.ReadInteger(mw.sdev, 'swf', 0) > 0;
		inv.Checked := mw.dini.ReadInteger(mw.sdev, 'inf', 0) > 0;
		dif.Value := mw.dini.ReadInteger(mw.sdev, 'dif', 10);
		min.Value := mw.dini.ReadInteger(mw.sdev, 'krz', 1);
		max.Value := mw.dini.ReadInteger(mw.sdev, 'lng', 127);

		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfStp.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[0] := pin.Adr;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);

		if plh.Checked
		then mw.dini.WriteInteger(mw.sdev, 'phi', 4)
		else mw.dini.WriteInteger(mw.sdev, 'phi', 0);
		if rdy.Checked
		then mw.dini.WriteInteger(mw.sdev, 'swf', 2)
		else mw.dini.WriteInteger(mw.sdev, 'swf', 0);
		if inv.Checked
		then mw.dini.WriteInteger(mw.sdev, 'inv', 1)
		else mw.dini.WriteInteger(mw.sdev, 'inv', 0);
		mw.dini.WriteInteger(mw.sdev, 'dif', dif.Value);
		mw.dini.WriteInteger(mw.sdev, 'krz', min.Value);
		mw.dini.WriteInteger(mw.sdev, 'lng', max.Value);

		mw.w.SetMess(0, sta0, 0 xor byte(inv.Checked));
		mw.w.SetMess(0, sta1, 1 xor byte(inv.Checked));
		if asnd.Checked
		then begin
			mbs_mon_f.mon.items.Add(format('hst sendpar %d',
					[tcomponent(sender).tag]));
			case tcomponent(sender).tag of
			1: mw.w.puttst(0, par1, tsta(byte(mw.w.stat) xor 1));
			2: mw.w.puttst(0, par2, sta0);
			3: mw.w.puttst(0, par3, sta1);
			end;
		end;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfStp.draw(f: tmbs_fld);
const
	d = gr div 3 - 1;
	r: TRect = (left: d - 1;
					Top: d - 1;
					Right: gr - d + 2;
					bottom: gr - d + 2);
begin
	with mw.bm.Canvas
	do begin
		pen.Width := 2;
		pen.Color := clred;
		if f.stat = sta1
		then pen.Color := clgray;
		f.DrawConn(f.conn, 5, 4);
	end;
end;

// empangene meldungen
procedure TfStp.RecMess(fld: tmbs_fld; mess: boolean);
begin
end;

// statusnderung
procedure TfStp.SetStat(fld: tmbs_fld; stat: tsta);
begin
	fld.setstatcom(stat);
end;

// statusnderung durch Click
procedure TfStp.ChngStat;
var
	p:			TPoint;
begin
	pmn.Visible := mw.test;
	p.x := mw.w.X * gr;
	p.y := mw.w.Y * gr;
	if mw.w.X < mw.trenn
	then p := mw.i1.ClientToScreen(p)
	else p := mw.i2.ClientToScreen(p);
	pm.Popup(p.x, p.y);
end;

procedure TfStp.pmnClick(Sender: TObject);
begin
	mw.w.NextStat;			// umschalten
end;

// statustabelle versorgen
procedure TfStp.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptsrv;
	fld.stan := 2;
end;

end.
