unit mbs_trn;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfTrn =
	class(TForm)
		par: TGroupBox;
		ldif: TLabel;
		lmax: TLabel;
		pin: Tmbs_led;
		lmin: TLabel;
		plh: TCheckBox;
		rdy: TCheckBox;
		inv: TCheckBox;
		min: Tmbs_epd;
		max: Tmbs_epd;
		dif: Tmbs_epd;
		dre: TCheckBox;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure Setwrt(d, k, r: byte);
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure RecMess(fld: tmbs_fld; mess: boolean);
		procedure ChngStat;
		procedure draw(fld: tmbs_fld);
	end;

var
	fTrn:			TfTrn;

implementation

uses mbs_bea_u, mbs_uhr_u;

{$R *.DFM}

procedure TfTrn.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfTrn.Setwrt(d, k, r: byte);
begin
	dif.Value := mw.dini.ReadInteger(mw.sdev, 'dif', d);
	min.Value := mw.dini.ReadInteger(mw.sdev, 'krz', k);
	max.Value := mw.dini.ReadInteger(mw.sdev, 'lng', r);
end;

procedure TfTrn.GetPar;
var
	v:			Tmbs_vrb;
	n: string;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		if mw.w.ftyp = ft3wg
		then mw.w.stan := 3
		else mw.w.Stan := 2;
		if mw.w.ftyp = ftekw
		then dre.Visible := true
		else dre.Visible := false;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := (mw.w.Stan > 2);
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;

		pin.adr := mw.w.ad[dev.itemindex];
		iniset(pin.adr.dc, pin.adr.dv, true);

		plh.Checked := mw.dini.ReadInteger(mw.sdev, 'phi', 1) > 0;
		rdy.Checked := mw.dini.ReadInteger(mw.sdev, 'swf', 0) > 0;
		inv.Checked := mw.w.Ad[dev.ItemIndex].ms[sta0] > 0;
		n := mw.dini.ReadString(mw.sdev, 'nam', '');
		setwrt(10, 91, 99);
		if n = 'ABZWEIG'	then setwrt(10, 90 ,100);
		if n = 'SERVO'	   then setwrt(0, 90, 100);
		if n = 'ENTKUPP'	then setwrt(5, 60, 65);
		if n = 'HALTEST'	then setwrt(10, 10, 120);
		if n = 'WEICHE'	then setwrt(10, 90, 100);

		par.Caption := 'Weiche ' + inttostr(dev.itemindex + 1);
		dre.Checked := mw.w.GetIpar(par3) > 0;
		mw.w.FstVerb;
		while mw.w.GetVerb(v)
		do begin
		end;
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfTrn.SetPar(Sender: TObject);
var
	t: integer;
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[dev.ItemIndex] := pin.Adr;
		mw.dtab[mw.w.Ad[dev.itemindex].dc].f[mw.w.Ad[dev.itemindex].dv] := mw.w;
		mw.w.DelVerb(true);
// weiche					dev
//	0 = links				=0
// 1 = rechts				=1
// 2 = rechts				=1
		mw.w.SetIpar(par3, byte(dre.Checked));
		mw.w.SetIpar(par2, 0);
//		mw.w.SetDpar(dev.itemindex, par0, byte(plh.checked) shl 2
//						  + byte(rdy.checked) shl 1);
//		mw.w.SetDpar(dev.itemindex, par1, dif.Value);
//		mw.w.SetDpar(dev.itemindex, par2, min.Value);
//		mw.w.SetDpar(dev.itemindex, par3, max.Value);

		if plh.Checked
		then mw.dini.WriteInteger(mw.sdev, 'phi', 4)
		else mw.dini.WriteInteger(mw.sdev, 'phi', 0);
		if rdy.Checked
		then mw.dini.WriteInteger(mw.sdev, 'swf', 2)
		else mw.dini.WriteInteger(mw.sdev, 'swf', 0);
		mw.dini.WriteInteger(mw.sdev, 'dif', dif.Value);
		mw.dini.WriteInteger(mw.sdev, 'krz', min.Value);
		mw.dini.WriteInteger(mw.sdev, 'lng', max.Value);

		case mw.w.FTyp of
		fttrn, ftabz:
			begin
				mw.w.Ad[1] := adr_leer;
				mw.w.Ad[2] := adr_leer;
				mw.w.Ad[3] := adr_leer;
				mw.w.SetMess(dev.ItemIndex, sta0, 0 xor byte(inv.Checked));
				mw.w.SetMess(dev.ItemIndex, sta1, 1 xor byte(inv.Checked));
			end;
		ft3wg:
			begin
				mw.w.Ad[2] := adr_leer;
				mw.w.Ad[3] := adr_leer;
				mw.w.SetMess(dev.ItemIndex, sta0, 0 xor byte(inv.Checked));
				mw.w.SetMess(dev.ItemIndex, sta1,
							(1 - dev.ItemIndex) xor byte(inv.Checked));
				mw.w.SetMess(dev.ItemIndex, sta2, 1 xor byte(inv.Checked));
			end;
		ftekw:
			begin
				mw.w.Ad[2] := adr_leer;
				mw.w.Ad[3] := adr_leer;
				mw.w.SetMess(dev.ItemIndex, sta0, 0 xor byte(inv.Checked));
				mw.w.SetMess(dev.ItemIndex, sta1, 1 xor byte(inv.Checked));
			end;
		ftdkw:
			begin
				mw.w.SetMess(dev.ItemIndex, sta0, 0 xor byte(inv.Checked));
				mw.w.SetMess(dev.ItemIndex, sta1, 1 xor byte(inv.Checked));
			end;
		end;
		mw.w.FTyp := mw.w.FTyp;
		if asnd.Checked
		then begin
			t := tcomponent(sender).tag;
			case t of
			0: mw.w.putpar;
			1: mw.w.puttst(dev.ItemIndex, par1, tsta(byte(mw.w.stat) xor 1));
			2: mw.w.puttst(dev.ItemIndex, par2, sta0);
			3: mw.w.puttst(dev.ItemIndex, par3, sta1);
			end;
		end;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfTrn.draw(fld: tmbs_fld);
begin
	with mw.bm.Canvas
	do begin
		if fld.ftyp >= ftStr
		then Pen.Color := clgray
		else Pen.Color := clblack;
		fld.Drawconn(byte(fld.GetStab), 5, 4);
		pen.color := clyellow;
		fld.DrawConn(byte(fld.GetStab), 3, 2);
	end;
end;

// empangene meldungen
procedure TfTrn.RecMess(fld: tmbs_fld; mess: boolean);
begin
end;

// statusnderung
procedure TfTrn.SetStat(fld: tmbs_fld; stat: tsta);
var
	zsta:		tsta;
begin
	case stat of
	sta7: mbs_uhr_f.delktimer(fld);
	belp:	inc(fld.Z.Blgt);
	belm: if fld.blgt > 0
		then dec(fld.Z.Blgt)
		else exit;
	end;
	zsta := fld.stat;
	fld.setstatcom(stat);
	case fld.stat of
	sta7: begin
			fld.Z.Blgt := 0;
			fld.stat := sta0;
		end;
	belp: begin
			if fld.blgt = 1
			then fld.Stat := sta1
			else fld.Stat := zsta;
		end;
	belm: begin
			if fld.blgt = 0
			then fld.Stat := sta4
			else fld.Stat := zsta;
		end;
	end;
	fld.Paint(0);
end;

// statusnderung durch Click bei bearbeiten
procedure TfTrn.ChngStat;
begin
	mw.w.NextStat;
end;

// statustabelle versorgen
procedure TfTrn.SetStab(fld: tmbs_fld);
var
	b0,
	b1,
	b2,
	wu:		byte;
begin
	fld.PTyp := ptsrv;
	case fld.FTyp of
	fttrn,
	ftabz:
		begin
			// gerade bestimmen
			b0 := mw.w.conn and (mw.w.Conn shl 4 or mw.w.Conn shr 4);
			// abzweigung
			b1 := mw.w.conn - b0;
			wu := b0 and not mbs_uhr_f.rolb(b1, 1)
						and not mbs_uhr_f.rorb(b1, 1);
			fld.Z.Stab[sta0] := b0;
			fld.Z.Stab[sta1] := wu + b1;
			fld.Z.Stab[sta7] := wu;
			fld.Ad[1] := adr_leer;
			fld.Ad[2] := adr_leer;
			fld.Ad[3] := adr_leer;
		end;
	ft3wg:
		begin
			b0 := mw.w.conn and (mw.w.Conn shl 4 or mw.w.Conn shr 4);
			b1 := mw.w.conn and mbs_uhr_f.rolb(b0, 1);
			b2 := mw.w.conn and mbs_uhr_f.rorb(b0, 1);
			wu := b0 and not mbs_uhr_f.rolb(b1, 1)
						and not mbs_uhr_f.rorb(b1, 1);
			fld.Z.Stab[sta0] := wu + b2;
			fld.Z.Stab[sta1] := b0;
			fld.Z.Stab[sta2] := wu + b1;
			fld.Z.Stab[sta7] := wu;
			fld.Ad[2] := adr_leer;
			fld.Ad[3] := adr_leer;
		end;
	ftekw:
		begin
			fld.Z.Stab[sta0] := 0;
			case mw.w.Conn and $03 of
			0:	b0 := $78;
			1: b0 := $0f;
			2: b0 := $1e;
			3: b0 := $3c;
			end;
			if fld.Z.Parm[par3] > 0
			then fld.Z.Stab[sta1] := mw.w.Conn and b0
			else fld.Z.Stab[sta1] := mw.w.Conn and not b0;
			mw.w.Paint(1);
			fld.Ad[2] := adr_leer;
			fld.Ad[3] := adr_leer;
		end;
	ftdkw:
		begin
			fld.Z.Stab[sta0] := 0;
			fld.Z.Stab[sta1] := mw.w.Conn;
		end;
	end;
end;

end.
