unit mbs_uhr_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls,
	ImgList, ExtCtrls, inifiles, printers,
	mbs_fld;

type
	Tmbs_uhr_f = class(TForm)
		uhr: TLabel;
		inf2: TLabel;
		kti: TTimer;
		il: TImageList;
		uim: TImage;
		infx: TLabel;
	 	infy: TLabel;
		procedure FormActivate(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure 	tiTimer(Sender: TObject);
		procedure 	ktiTimer(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure inf2Click(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure	setimage;
	public		{ Public-Deklarationen }
		function 	addtimer(
							feld: 	Tmbs_fld;		// feld
							ztyp:		tttyp;			// timertyp
							stap:		boolean;			// status weiterzhlen
							begv,                   // startverzgerung
							ontm,                   // ontime
							rtim,							// wiederholungszeit
							wieo:		integer			// wie oft
							): boolean;
		function 	addktimer(
							feld: 	Tmbs_fld;		// feld
							begv:		integer;			// startverzgerung
							ssta:		tsst	 			// set status
							): boolean;
		procedure 	delktimer(
							feld: 	Tmbs_fld			// feld
							);
		procedure 	adddec(f: Tmbs_fld; port, dec, dev: byte);
		procedure 	aktdec(port, dec: byte);
		function 	getfeld(port, dec, dev: byte): Tmbs_fld;
		procedure 	anlage_n();
		procedure 	anlage_l(fn: string);
		procedure 	anlage_s(fn: string);
		procedure 	putinf(f: Tmbs_fld);
		procedure 	Modechange(mode: byte);
		procedure 	ChangeCont(w: Tmbs_fld);
		procedure 	Loadtime(var f: file; i, l: integer);
		procedure 	Savetime(var f: file; i: integer);
		procedure 	druck;
		procedure 	fld2dec(t: longint);
		function rolb(ein: byte; bits: byte): byte;
		function rorb(ein: byte; bits: byte): byte;
	end;

var
	mbs_uhr_f: 	Tmbs_uhr_f;
	mw:			ptmbswork;
//	ztab:			array [1..99] of Tmbszug;
	znum:			byte;
	mtim:			byte;

implementation

uses mbs_bea_u, mbs_ver_u, mbs_weg_u, ape_u, mbs_ext_u,
		mbs_anl_u, mbs_u, mbs_mon_u;

{$R *.DFM}

procedure Tmbs_uhr_f.FormCreate(Sender: TObject);
begin
	inherited;

	mw := ptmbswork(application.Tag);
end;

procedure Tmbs_uhr_f.FormActivate(Sender: TObject);
var
	i:			integer;
begin
	if Tag > 0
	then exit;
	tag := 0;
	for i := low(mw.ktab) to high(mw.ktab)
	do begin
		mw.ktab[i].c := -1;
	end;
end;

function Tmbs_uhr_f.rolb(ein: byte; bits: byte): byte;
var
	h: 		word;
begin
	h := ein shl (bits and $7);
	result := h shr 8 + h and $ff;
end;

function Tmbs_uhr_f.rorb(ein: byte; bits: byte): byte;
var
	h: 		word;
begin
	h := ein shl (8 - (bits and $7));
	result := h shr 8 + h and $ff;
end;

procedure Tmbs_uhr_f.fld2dec(t: longint);
var
	i,
	j:			word;
begin
	if t > 0
	then begin
		i := (t and $30000) shr 16
					 + (t shr 8) and $7f;
		j := t and $0f;
		mw.dtab[i].f[j] := mw.w;
	end;
end;

function Tmbs_uhr_f.addtimer(
		feld: 	Tmbs_fld;		// feld
		ztyp:		tttyp;			// timertyp
		stap:		boolean;			// status weiterzhlen
		begv,                   // startverzgerung
		ontm,                   // ontime
		rtim,							// wiederholungszeit
		wieo:		integer			// wie oft
		): boolean;
var
	i:			integer;
begin
	for i := low(mw.ttab) to high(mw.ttab)
	do begin
		if mw.ttab[i].z = ttnone
		then begin
			mw.ttab[i].t := tsbeg;
			mw.ttab[i].c := begv;
			mw.ttab[i].a := wieo;
			mw.ttab[i].z := ztyp;
			mw.ttab[i].f := feld;
			mw.ttab[i].s := stap;
			mw.ttab[i].b := begv;
			mw.ttab[i].o := ontm;
			mw.ttab[i].r := rtim;
			mw.ttab[i].w := wieo;
			result := true;
			exit;
		end;
	end;
	showmessage('Timertabelle voll');
	result := false;
end;

procedure Tmbs_uhr_f.adddec(f: Tmbs_fld; port, dec, dev: byte);
begin
	mw.dtab[port * 128 + dec].f[dev] := f;
{ TODO : Decoderbeschreibung lesen }
end;

procedure Tmbs_uhr_f.aktdec(port, dec: byte);
begin
	mw.dtab[port * 128 + dec].a := true;
end;

function Tmbs_uhr_f.getfeld(port, dec, dev: byte): Tmbs_fld;
begin
	result := mw.dtab[port * 128 + dec].f[dev];
end;

procedure Tmbs_uhr_f.anlage_s(fn: string);
var
	f: file;
	x,
	y:	integer;
	f1,
	f2: string;
begin
	if extractfileext(fn) > '.mba'
	then begin
		showmessage(fn + ' wird nicht gespeichert');
		exit;
	end;
	if messagedlg(extractfilename(fn) + ' speichern?',
				mtConfirmation, [mbyes, mbno], 0) = mrno
	then exit;
	for x := 9 downto 0
	do begin
		if x > 0
		then f1 := changefileext(fn, '.mba' + inttostr(x - 1))
		else f1 := fn;
		f2 := changefileext(fn, '.mba' + inttostr(x));
		if fileexists(f1)
		then copyfile(pchar(f1), pchar(f2), false);
	end;
	assignfile(f, fn);
	rewrite(f, 1);
	// grsse und trennung
	blockwrite(f, mw.ftabx, sizeof(mw.ftabx));
	blockwrite(f, mw.ftaby, sizeof(mw.ftaby));
	blockwrite(f, mw.trenn, sizeof(mw.trenn));
	// felder
	for x := 1 to mw.ftabx
	do begin
		for y := 1 to mw.ftaby
		do begin
			if assigned(mw.ftab[x, y])
			and (mw.ftab[x, y].FTyp <> ftNon)
			then begin
				mw.ftab[x, y].savefeld(f);
			end;
		end;
	end;
	// timer
	for x := low(mw.ttab) to high(mw.ttab)
	do begin
		if mw.ttab[x].t > tsleer
		then begin
			savetime(f, x);
		end;
	end;
	closefile(f);
	application.MainForm.Caption := fn;
end;

procedure Tmbs_uhr_f.anlage_n();
var
	i,
	j:			integer;
begin
	setimage;
	for i := low(mw.ttab) to high(mw.ttab)
	do begin
		mw.ttab[i].t := tsleer;
		mw.ttab[i].z := ttnone;
	end;
	for i := low(mw.dtab) to high(mw.dtab)
	do begin
		mw.dtab[i].a := false;
		for j := 1 to 13
		do begin
			mw.dtab[i].f[j] := nil;
//			mw.dtab[i].t[j] := ptnon;
		end;
	end;
	application.MainForm.Caption := 'untitled';
end;

procedure Tmbs_uhr_f.setimage();
var
	i,
	j:			integer;
begin
	if mw.ftabx > mw.trenn
	then begin
		mw.i1.Width := (mw.trenn - 1) * gr + 1;
		mw.i2.Width := (mw.ftabx - mw.trenn + 1) * gr + 1;
		mw.i2.Height := mw.ftaby * gr + 1;
		mw.i2.Picture.Bitmap.Height := mw.i2.Height;
		mw.i2.Picture.Bitmap.width := mw.i2.Width;
//		mbs_ext_f.show;
//		mbs_f.Ext1.Checked := true;
	end
	else begin
		mw.i1.Width := mw.ftabx * gr + 1;
//		mbs_ext_f.Hide;
//		mbs_f.Ext1.Checked := false;
	end;
	mw.i1.Height := mw.ftaby * gr + 1;
	mw.i1.Picture.Bitmap.Height := mw.i1.Height;
	mw.i1.Picture.Bitmap.width := mw.i1.Width;
	for i := low(mw.ftab) to mw.ftabx
	do begin
		for j := low(mw.ftab[1]) to mw.ftaby
		do begin
			mw.ftab[i, j].free;
			if i < mw.trenn
			then mw.ftab[i, j] := Tmbs_fld.Createxy(mw.i1, i, j)
			else mw.ftab[i, j] := Tmbs_fld.Createxy(mw.i2, i, j);
			mw.ftab[i, j].FTyp := ftnon;
			mw.ftab[i, j].Paint(0);
		end;
	end;
	for i := low(mw.dtab) to high(mw.dtab)
	do begin
		mw.dtab[i].a := false;
	end;
	for i := low(mw.ttab) to high(mw.ttab)
	do begin
		mw.ttab[i].t := tsleer;
	end;
end;

procedure Tmbs_uhr_f.anlage_l(fn: string);
var
	f: 		file;
	dc,
	dv:		byte;
	i,
	j,
	k:			integer;
	head:		THead;
	tdev: string;
begin
	assignfile(f, fn);
	reset(f, 1);
	blockread(f, mw.ftabx, sizeof(mw.ftabx));
	blockread(f, mw.ftaby, sizeof(mw.ftaby));
	blockread(f, mw.trenn, sizeof(mw.trenn));
	setimage;
	application.MainForm.Caption := fn;
	mbs_ext_f.caption := fn;
	while not eof(f)
	do begin
		blockread(f, head, sizeof(head));
		case head.leng and saart of
		safld:	// felder
			begin
				mw.w := mw.ftab[head.posx, head.posy];
				mw.ftab[head.posx, head.posy].loadfeld(f, head.leng and $0fff);
				mw.ftab[head.posx, head.posy].Paint(0);
			end;
		satim:	// timer
			begin
				loadtime(f, i, head.leng and $0fff);
				inc(i);
			end;
		else seek(f, filepos(f) + head.leng and $0fff);
		end;
	end;
	closefile(f);
	if assigned(mw.dini)
	then mw.dini.Free;
	tdev := changefileext(fn, '.ini');
	mw.dini := tinifile.Create(tdev);
	for dc := 1 to 127
	do begin
		if mw.dini.SectionExists(format('Decoder%3.3d', [dc]))
		then begin
			for dv := 1 to 13
			do begin
				mbs_bea_f.iniset(dc, dv, false);
				if dv = 1
				then mw.dtab[dc].s := mw.dini.ReadString(mw.sdec, 'dec', '');
				if mw.sdev > ' '
				then begin
					mw.dtab[dc].n[dv] := mw.sdev;
				end;
				tdev := mw.dini.ReadString(mw.sdev, 'typ', '');
				mw.dtab[dc].t[dv] := ptnon;
			end;
		end;
	end;
	for i := 1 to mw.ftabx
	do begin
		for j := 1 to mw.ftaby
		do begin
			for k := 0 to 3
			do begin
				dc := mw.ftab[i, j].Ad[k].dc;
				if (dc > 0)
				and (dc < 128)
				then begin
					dv := mw.ftab[i, j].Ad[k].dv;
					mw.dtab[dc].f[dv] := mw.ftab[i, j];
					mw.dtab[dc].t[dv] := mw.ftab[i, j].PTyp;
				end;
			end;
		end;
	end;
end;

procedure Tmbs_uhr_f.putinf(f: Tmbs_fld);
const
	pkey = '%s:%d Zug: %d>%d';
	dkey = '%3d:%2.2d=%s';
begin
	if not Assigned(f)
	then exit;
	infx.Caption := inttostr(f.x);
	infy.Caption := inttostr(f.y);
	if f.ftyp = ftnon
	then begin
		Caption := '';
		inf2.Caption := '';
		exit;
	end;
	Caption := format(pkey,
					[sftab[byte(f.ftyp)],
					byte(f.stat), f.blgt, F.zugw, f.zugn]);
	if (f.Ad[0].dc > 0)
	and (f.Ad[0].dc < 256)
	and inf2.visible
	then inf2.Caption := format(dkey,
							[f.ad[0].dc,
							f.ad[0].dv,
							mw.dtab[f.ad[0].dc].n[f.ad[0].dv]])
	else inf2.Caption := '';
//		if f.zugn > 0
//		then inf1.default := true
//		else mw.mi11.default := false;
end;

procedure Tmbs_uhr_f.Modechange(mode: byte);
var
	x,
	y:			word;
begin
	mw.mode := mode;
	mbs_bea_f.hide;
	mbs_ver_f.hide;
	mbs_weg_f.hide;
	mbs_anl_f.hide;
	for x := 1 to mw.ftabx
	do begin
		for y := 1 to mw.ftaby
		do begin
			mw.ftab[x, y].Paint(0);
		end;
	end;
	case mw.mode of
	0:		// fahren
		begin
			if mw.run
			then begin
				kti.Enabled := true;
				uhr.Font.Color := clblack;
			end;
			if assigned(mw.v)
			then begin
				mw.v.Paint(0);
				mw.v := nil;
			end;
			if assigned(mw.w)
			then begin
				mw.w.Paint(0);
				mw.w := nil;
			end;
			application.mainform.Brush.Color := clbtnface;
			application.mainform.Repaint;
			mbs_ext_f.Brush.Color := clbtnface;
			mbs_ext_f.Repaint;
		end;
	1:	  	// bearbeiten
		begin
//			mbsbeaf.Show;
			for x := 1 to mw.ftabx
			do begin
				for y := 1 to mw.ftaby
				do begin
					mw.ftab[x, y].Paint(9);
				end;
			end;
			kti.Enabled := false;
			uhr.Font.Color := clsilver;
			mw.v := nil;
			if assigned(mw.w)
			then begin
				mw.w := nil;
			end
			else begin
			end;
			application.mainform.Brush.Color := clred;
			mbs_ext_f.Brush.Color := clred;
		end;
	2:	  	// verbinden
		begin
//			mbsverf.Show;
			kti.Enabled := false;
			uhr.Font.Color := clsilver;
			mw.v := nil;
			if assigned(mw.w)
			then begin
				mw.w.Paint(0);
				mw.w := nil;
			end
			else begin
			end;
			application.mainform.Brush.Color := cllime;
			mbs_ext_f.Brush.Color := cllime;
		end;
	3:	  	// wege verlegen
		begin
//			mbswegf.Show;
			kti.Enabled := false;
			uhr.Font.Color := clsilver;
			mw.v := nil;
			if assigned(mw.w)
			then begin
				mw.w.Paint(0);
			end
			else begin
			end;
			application.mainform.Brush.Color := clred;
			mbs_ext_f.Brush.Color := clred;
		end;
	4:	  	// anlage ndern
		begin
			kti.Enabled := false;
			uhr.Font.Color := clsilver;
			mw.v := nil;
			application.mainform.Brush.Color := clnavy;
			mbs_ext_f.Brush.Color := clnavy;
			mbs_anl_f.Show;
		end;
	end;
	mw.mo1.Items[mw.mode].Checked := true;
	mw.mo1.Caption := mw.mo1.Items[mw.mode].Caption;
	mw.mo2.Items[mw.mode].Checked := true;
	mw.mo2.Caption := mw.mo2.Items[mw.mode].Caption;
end;

procedure Tmbs_uhr_f.ChangeCont(w: Tmbs_fld);
var
	wv:		Tmbs_vrb;
	f:			Tmbs_fld;
begin
	if not assigned(w)
	then exit;
	if w.Stat = sta0
	then begin
		// freigeben block mittels eingetragenem Signal
		w.FstVerb;
		while w.GetVerb(wv)
		do begin
			f := mw.ftab[wv.x, wv.y];
			if wv.wst = sta0
			then begin
				f.beleg(f.Isol, 127, nil, nil);
				w.DelVerb(wv);
				break;
			end;
		end;
	end
	else begin
//		setstr;
	end;
end;

procedure Tmbs_uhr_f.tiTimer(Sender: TObject);
var
	i:			integer;
	f:			Tmbs_fld;
	t:			ptmbstim;
	bm:		tbitmap;
begin
	bm := tbitmap.Create;
	kti.Tag := kti.Tag + 1;
	if kti.Tag = 1440
	then kti.Tag := 0;

	uhr.Caption := format('%2d:%2.2d',
				[kti.tag div 60, kti.tag mod 60]);
	if kti.tag > mw.znch
	then il.GetBitmap(0, bm)
	else if kti.tag > mw.zabe
		then il.GetBitmap(3, bm)
		else if kti.tag > mw.ztag
			then il.GetBitmap(2, bm)
			else if kti.tag > mw.zmor
				then il.GetBitmap(1, bm)
				else il.GetBitmap(0, bm);
	uim.Picture.Bitmap := bm;
	bm.Free;

	for i := low(mw.ttab) to high(mw.ttab)
	do begin
		t := addr(mw.ttab[i]);
		if (t.t > tsleer)
		and (t.t < tsrdy)
		then begin
			f := mw.ttab[i].f;
			if (t.z = mw.tim)
			or (t.z = ttstart)
			then begin
				dec(t.c);
				if t.c = 0
				then begin
					case t.t of
					tsbeg:
						begin
							t.c := t.b;	// zeit bis on
							t.t := tsbon;
							t.a := t.w;
						end;
					tsbon:
						begin
							t.t := tson;
							if t.o = 0
							then begin
								if t.s
								then f.NextStat
								else f.Stat := sta1;
								t.t := tsrdy;
							end
							else t.c := t.o;
						end;
					tson:
						begin
							if t.s
							then f.NextStat
							else f.Stat := sta1;
							if (t.r > 0)
							and (t.a > 0)
							then begin
								if t.s
								then f.NextStat
								else f.Stat := sta0;
								t.c := t.r;
								t.t := tsbon;
								dec(t.a);
							end
							else begin
								t.t := tsrdy;
							end;
						end;
					end;
				end;
				if t.t = tsrdy
				then begin
					if t.s
					then f.NextStat;
				end;
				if t.l
				then t.t := tsleer;
			end
			else begin
				f.stat := sta0;
				t.t := tsbon;
			end;
		end;
	end;
end;

procedure Tmbs_uhr_f.Loadtime(var f: file; i, l: integer);
begin
	blockread(f, mw.ttab[i], l);
	mw.ttab[i].t := tsbeg;
	mw.ttab[i].c := mw.ttab[i].b;  	// laufende zeit
	mw.ttab[i].a := 0;					// wie oft noch
end;

procedure Tmbs_uhr_f.Savetime(var f: file; i: integer);
var
	head:		THead;
begin
	head.leng := satim + sizeof(Tmbs_tim);
	head.Posx := 0;
	head.Posy := 0;
	blockwrite(f, head, sizeof(head));
	blockwrite(f, mw.ttab[i], head.leng and $0fff);
end;

procedure Tmbs_uhr_f.ktiTimer(Sender: TObject);
var
	i:			integer;
	lb:		tlistbox;
begin
	for i := low(mw.ktab) to high(mw.ktab)
	do begin
		if mw.ktab[i].c > -1  // -1 ist leer
		then begin
			if mw.ktab[i].c = 0
			then begin
				if mw.ktab[i].s = stal
				then mw.ktab[i].f.NextStat
				else mw.ktab[i].f.Stat := mw.ktab[i].s;
			end;
			dec(mw.ktab[i].c);
		end;
	end;
	dec(mtim);
	if mtim = 0
	then begin
		mtim := mw.min;
		titimer(kti);
	end;
	if mbs_mon_f.K1.Checked
	or mbs_mon_f.W1.Checked
	then begin
		lb := mbs_mon_f.lb;
		lb.Clear;
		for i := low(mw.ktab) to high(mw.ktab)
		do begin
			if mw.ktab[i].c > -1
			then lb.Items.Add(format('%3d %3d:%d:%s',
				[mw.ktab[i].c, mw.ktab[i].f.x,
				mw.ktab[i].f.y,
				sftab[integer(mw.ktab[i].f.ftyp)]]));
		end;
		if mbs_mon_f.W1.Checked
		and (lb.Items.Count > 0)
		then begin
			kti.Enabled := false;
			uhr.Font.Color := clsilver;
			showmessage('weiter');
			kti.Enabled := true;
			uhr.Font.Color := clblack;
		end;
	end;
end;

function Tmbs_uhr_f.addktimer(
		feld: 	Tmbs_fld;		// feld
		begv:		integer;			// startverzgerung
		ssta:		tsst	 			// set status
		): boolean;
var
	i:			integer;
begin
	if begv > 0
	then begin;
		result := true;
		for i := low(mw.ktab) to high(mw.ktab)
		do begin
			if mw.ktab[i].c = -1
			then begin
				mw.ktab[i].c := begv;
				mw.ktab[i].s := tsta(ssta);
				mw.ktab[i].f := feld;
				exit;
			end;
		end;
		showmessage('Kurztimertabelle voll');
	end;
	result := false;
end;

procedure Tmbs_uhr_f.delktimer(
		feld: 	Tmbs_fld			// feld
		);
var
	i:			integer;
begin
	for i := low(mw.ktab) to high(mw.ktab)
	do begin
		if mw.ktab[i].f = feld
		then begin
			mw.ktab[i].c := -1;
			break;
		end;
	end;
end;

procedure Tmbs_uhr_f.druck;
const
	f = 5;
var
	r:			trect;
begin
	if mw.pri > printer.Printers.Count - 1
	then printer.PrinterIndex := -1
	else printer.PrinterIndex := mw.pri;
	if not mbs_ext_f.pd.Execute
	then exit;
	mw.pri := printer.PrinterIndex;
	Printer.Orientation := poLandscape;
	printer.Title := extractfilename(application.mainform.Caption);
	Printer.BeginDoc;
	if mbs_ext_f.Visible
	then begin
		r.Left := (Printer.PageWidth
					- mw.i1.Picture.Bitmap.Width * f
					- mw.i2.Picture.Bitmap.Width * f) div 2;
	end
	else begin
		r.Left := (Printer.PageWidth
					- mw.i1.Picture.Bitmap.Width * f) div 2;
	end;
	printer.Canvas.TextOut(r.left, 20, printer.Title);
	r.Top := (Printer.PageHeight - mw.i1.Picture.Bitmap.Height * f) div 2;
	r.Bottom := r.top + mw.i1.Picture.Bitmap.Height * f;
	r.Right := r.Left + mw.i1.Picture.Bitmap.Width * f;
	Printer.Canvas.StretchDraw(r, mw.i1.Picture.Bitmap);
	if mbs_ext_f.Visible
	then begin
//		printer.NewPage;
		r.Left := r.Right - f;//(Printer.PageWidth - mw.i2.Picture.Bitmap.Width * f) div 2;
//		r.Top := (Printer.PageHeight - mw.i2.Picture.Bitmap.Height * f) div 2;
//		r.Bottom := r.top + mw.i2.Picture.Bitmap.Height * f;
		r.Right := r.Left + mw.i2.Picture.Bitmap.Width * f;
		Printer.Canvas.StretchDraw(r, mw.i2.Picture.Bitmap);
	end;
	Printer.EndDoc;
end;

procedure Tmbs_uhr_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	mw.muhr.click;
	action := cahide;
end;

procedure Tmbs_uhr_f.inf2Click(Sender: TObject);
begin
	inf2.Visible := inf2.visible xor true;
end;

end.
